program cal;
uses
  winTTT5,
  fastTTT5,
  strnTTT5,
  keyTTT5,
  readttt5,
  crt,
  dos;

type
  tm_type    = string[10]; {yymmddhhmm}
var
  BoxF : byte;    {box foreground color}
  Fore : byte;    {Misc. text foreground color}
  Back : byte;    {main background color}
  MsgF : byte;    {message foreground color}
  MsgB : byte;    {message background color}
  ErrF : byte;    {error message foreground color}
  ErrB : byte;    {error message background color}
  HiF  : byte;    {highlighted field foreground color}
  HiB  : byte;    {highlighted field background color}
  LoF  : byte;    {normal field foreground color}
  LoB  : byte;    {normal field background color}

{----------------------------------------------------------------------}

function val2_of(d1,d2:char):word;
{returns a value of a 2 character string}
begin
  if not (d1 in ['0'..'9']) then d1 := '0';
  if not (d2 in ['0'..'9']) then d2 := '0';
  val2_of := (ord(d1)-48)*10 + ord(d2)-48;
end;

{----------------------------------------------------------------------}

function d2(w:word):string;

{converts w to a two digit string with leading zeros.}

begin
  d2 := char(w div 10 + 48) + char(w mod 10 + 48);
end;

{----------------------------------------------------------------------}

function is_blank(s:string):boolean;
var
  i : byte;
  all_blank : boolean;
begin
  all_blank := true;
  i := length(s);
  while (i > 0) and all_blank do begin
    if s[i] <> ' ' then all_blank := false;
    dec(i);
  end;
  is_blank := all_blank;
end;

{----------------------------------------------------------------------}
Procedure Set_Colors;

begin
  If ColorScreen then begin
    BoxF := yellow;
    Fore := LightCyan;
    Back := blue;
    MsgF := Black;
    MsgB := LightGray;
    ErrF := white;
    ErrB := red;
    HiF  := white;
    HiB  := red;
    LoF  := white;
    LoB  := Cyan;
  end
  else begin
    BoxF := white;
    Fore := Lightgray;
    Back := black;
    MsgF := black;
    MsgB := lightgray;
    ErrF := black;
    ErrB := lightgray;
    HiF  := black;
    HiB  := lightgray;
    LoF  := white;
    LoB  := black;
  end;
  RTTT.Fcol := MsgF;
  RTTT.Bcol := MsgB;
end; {of proc Set_Colors}

(*
{$F+}
{$V-}

unit on_util;

interface

uses
  on_gbl,
  winTTT5,
  fastTTT5,
  strnTTT5,
  keyTTT5,
  readttt5,
  crt,
  dos;

procedure set_time_to_server_time;
procedure msg(msg_text:string);
procedure err_msg(msg_text:string);
procedure msg_delay(msg_text:string);
procedure display_msg(msg_text, bottom:string; Fcolor, Bcolor :byte);
procedure display_msg_xy(x,y:byte; msg_text, bottom:string; Fcolor, Bcolor :byte);
function ask(prompt:string; size:byte):string;
procedure get_str(prompt:string; var str:strscreen; size:byte);
procedure set_time;
procedure write2color(x,y,f1,b1,f2,b2:integer; s:string);
procedure crash(msg:string);
function blanks(n:byte):string;
function trim(s:string) : string;
function pad(s:string; l:byte) : string;
function pos_of(var str:string; var buf; size, starting_at : word;
                  case_insensitive: boolean): word;
function is_blank(s:string):boolean;
function str2_of(i:word):string;
function val2_of(d1,d2:char):word;
function d2(w:word):string;
function alt_key_is_pressed:boolean;
function max(i, j:integer):integer;
function min(i, j:integer):integer;
procedure beep;
function current_time:time_type;
function current_tm:tm_type;
function tm_to_time(tm:tm_type):time_type;
function tm_to_tmfld(tm:tm_type):tmfld_type;
function tmfld_to_tm(tmfld:tmfld_type):tm_type;
function valid_tm(tm:tm_type):boolean;
procedure get_password(var users_guess:string);
procedure get_new_password(var users_guess:string; var updated:boolean);
function encrypt(password:string):string;
*)
(*
procedure display_calendar;
function d_to_j(m,d,y:word):longint;
procedure j_to_d(j:longint; var m,d,y : word);
function tm_to_tj(tm:tm_type):longint;
function tj_to_tm(tj:longint):tm_type;
function mm_slash_dd_slash_yy_to_yymmdd(s:string):string;
*)

type
  {enum type representing the 7 days of the week}
  DayOfTheWeek     = (Sunday,Monday,Tuesday,Wednesday,Thursday,
                      Friday,Saturday);

  {the date/time record used internally by NetWare.  The year is stored as
   a byte.  If the year is greater than or equal to 80, then the year refers
   to the twentieth century (1980-1999), if it is less than 80, then it refers
   to a year in the twenty-first century
  }
  NovDateType      = record
                       Year,                     {80=1980}
                       Month,
                       Day,
                       Hour,
                       Minute,
                       Second     : Byte;
                       WeekDay    : DayOfTheWeek;
                       Filler     : Byte;    {!!.03}
                     end;
(*
{----------------------------------------------------------------------}

procedure GetServerDateTime(var Year : Word;
                            var Month,Day,Hour,Minute,Second : Byte;
                            var WeekDay : DayOfTheWeek);

type
  ReplyBuffer      = array[1..10] of Byte;

var
  NovRegs          : Registers; { register type for DOS/Novell calls }
  Reply            : ReplyBuffer;

begin
  with NovRegs do begin
    AX := $E700;
    DS := Seg(Reply);    {point DS:DX at buffer}
    DX := Ofs(Reply);
  end; {with}
  MsDos(NovRegs);        {issue the call}
  Year    := Word(Reply[1]) + 1900;  {return year}
  Month   := Word(Reply[2]);         {return month}
  Day     := Word(Reply[3]);         {return day}
  Hour    := Word(Reply[4]);         {return hour}
  Minute  := Word(Reply[5]);         {return minute}
  Second  := Word(Reply[6]);         {return second}
  WeekDay := DayOfTheWeek(Reply[7]); {return the day of the week as enum}
end;

{----------------------------------------------------------------------}

procedure set_time_to_server_time;
var
  year : word;
  month,day,hour,minute,second : byte;
  weekday : dayoftheweek;
begin
  GetServerDateTime(Year,Month,Day,Hour,Minute,Second,WeekDay);
  settime(hour,minute,second,0);
  setdate(year,month,day);
end;

{----------------------------------------------------------------------}

procedure display_msg_xy(x,y:byte; msg_text, bottom:string; Fcolor, Bcolor :byte);
var
  c : char;
  i,n,l,p :  integer;
  s : array[1..10] of string[80];
begin
  l := 28;
  i := 0;
  repeat
    inc(i);
    p := pos('~', msg_text);
    if p = 0 then s[i] := msg_text
    else begin
      s[i] := copy(msg_text,1,p-1);
      msg_text := copy(msg_text, p+1, 255);
    end;
    l := max(l, length(s[i]));
  until p = 0;
  n := i;
  mkwin(x, y, x+l+1, y+n+1, Fcolor, Bcolor, 1{single line boxtype});
  for i := 1 to n do PlainWrite(x+1, y + i, s[i]);
  writecenter(y + n + 1, Fcolor, Bcolor, bottom);

  { DO NOT FORGET TO RMWIN !!!}

end;
{----------------------------------------------------------------------}

procedure display_msg(msg_text, bottom:string; Fcolor, Bcolor :byte);
var
  c : char;
  i,n,l,p :  integer;
  s : array[1..10] of string[80];
begin
  l := 28;
  i := 0;
  repeat
    inc(i);
    p := pos('~', msg_text);
    if p = 0 then s[i] := msg_text
    else begin
      s[i] := copy(msg_text,1,p-1);
      msg_text := copy(msg_text, p+1, 255);
    end;
    l := max(l, length(s[i]));
  until p = 0;
  n := i;
  mkwin(38 - l div 2, 7,
        42 + l div 2, 7 + n + 1, Fcolor, Bcolor, 6{double line w/ shadow});
  for i := 1 to n do PlainWrite(40 - l div 2, 7 + i, s[i]);
  writecenter(7 + n + 1, Fcolor, Bcolor, bottom);
end;

{----------------------------------------------------------------------}
procedure msg(msg_text:string);
var
  c : char;
begin
  display_msg(msg_text,' Press any key to continue ', MsgF, MsgB);
  offcursor;
  c := getkey;
  oncursor;
  rmwin;
end;

{----------------------------------------------------------------------}
procedure err_msg(msg_text:string);
var
  c : char;
begin
  display_msg(msg_text,' Press any key to continue ', ErrF, ErrB);
  offcursor;
  c := getkey;
  oncursor;
  rmwin;
end;

{----------------------------------------------------------------------}
procedure msg_delay(msg_text:string);
begin
  display_msg(msg_text,'',MsgF,MsgB);
  DelayKey(2000);
  rmwin;
end;

{----------------------------------------------------------------------}

function ask(prompt:string; size:byte):string;
var
  c : char;
  l : integer;
  ans : strscreen;
begin
  l := length(prompt) + size;
  SAVESCREEN(3);
  if size = 1 then begin
    mkwin(38 - l div 2, 7, 42 + l div 2, 9, MsgF, MsgB, 1);
    PlainWrite(40 - l div 2, 8, prompt);
    poscursor(40 + l div 2, 8);
    ask := upcase(getKey);
  end
  else begin {size not 1}
    ans := '';
    read_string(40 - l div 2, 8, size, prompt, 1, ans);
    ask := ans;
  end;
  RESTORESCREEN(3);
  DISPOSESCREEN(3);
end;

{----------------------------------------------------------------------}

procedure get_str(prompt:string; var str:strscreen; size:byte);
var
  c : char;
  l : integer;
  ans : strscreen;
begin
  l := length(prompt) + size;
  SAVESCREEN(3);
  read_string_upper(40 - l div 2, 8, size, prompt, 1, str);
  RESTORESCREEN(3);
  DISPOSESCREEN(3);
end;

{----------------------------------------------------------------------------}
procedure set_time;
var
  yr, mo, day, hr, min  : word;
  s : string[14];
begin
  s := ask('New HH:MM MM/DD/YY ? ', 14);
  if (s[3] = ':') and (s[9] = '/') and (s[12] = '/') then begin
    hr := val2_of(s[1],s[2]);
    min:= val2_of(s[4],s[5]);
    mo := val2_of(s[7],s[8]);
    day:= val2_of(s[10],s[11]);
    yr := val2_of(s[13],s[14]);
    settime(hr, min, 0, 0);
    setdate(yr mod 100 + 1900, mo,day);
  end
  else beep;
end;

{----------------------------------------------------------------------}

procedure write2color(x,y,f1,b1,f2,b2:integer; s:string);
var
  ls, p1,p2,tmp : integer;
  swc : char; {switch character}
begin
  ls := length(s);
  if ls > 1 then begin
    swc := s[1];
    p1 := 2;
    repeat
      p2 := p1;
      while (p2<ls) and (s[p2] <> swc) do inc(p2);
      if p2 > p1 then begin
        if p2 = ls then inc(p2); {to get last char}
        writeat(x,y,f1,b1,copy(s,p1,p2-p1));
        inc(x,p2-p1);
        p1 := p2 + 1;
        tmp := f1;
        f1 := f2;
        f2 := tmp;
        tmp := b1;
        b1 := b2;
        b2 := tmp;
      end;
    until p1 > ls;
  end;
end;

{----------------------------------------------------------------------}

procedure crash(msg:string);
begin
  beep;
  beep;
  beep;
  delaykey(3000); {wait 3 sec or until key is pressed}
  gotoxy(1,18);
  textbackground(red);
  textcolor(white+blink);
  writeln('!!! ONCALL SYSTEM CRASH !!!');
  writeln;
  writeln('   ',msg);
  writeln;
  writeln('System halted');
end;

{----------------------------------------------------------------------}

function blanks(n:byte): string;

var
  s : string;
  i : byte;
begin
  s[0] := char(n);
  for i := 1 to n do s[i] := ' ';
  blanks := s;
end;

{----------------------------------------------------------------------}

function trim(s:string) : string;
{ Strip trailing blanks from a string}
begin
  while s[ord(s[0])] = ' ' do dec(s[0]);
  trim := s;
end;

{----------------------------------------------------------------------}

function pad(s:string; l:byte) : string;
{ add blanks or clip s to be l characters long}
begin
  while length(s) < l do s := s + ' ';
  s[0] := char(l);
  pad := s;
end;

{----------------------------------------------------------------------}

function pos_of(var str:string; var buf; size, starting_at : word;
                case_insensitive:boolean): word;

{ This function finds the relative position of a string in a buffer         }
{ searching from a particular starting position.                            }
{   str is the string that you are looking for                              }
{   buf is the buffer that is searched                                      }
{   size is the size of the buffer in bytes                                 }
{   starting_at is the starting position of the search, 1 for the beginning }
{   pos_of returns 0 if the string is not found                             }
{   case_insensitive is TRUE if any case combination of str is a match      }
{                       FALSE if exact case str match required              }

var
  str_seg, str_ofs, str_len, buf_seg, buf_ofs, buf_ofs1, buf_ofs2, p : word;
  buf_Upcase, UC_buf_seg, UC_buf_ofs, UC_buf_ofs1, UC_buf_ofs2 : word;
  UC_buf  : pointer;
  i       : integer;
  Search_buf_seg, Search_buf_ofs, Search_buf_ofs1, Search_buf_ofs2 : word;


begin {pos_of}
  str_seg := seg(str) + ofs(str) div 16;
  str_ofs := ofs(str) mod 16 + 1;     {+ 1 to skip over the length byte}
  str_len := length(str);

  if case_insensitive then begin


    for i:= 1 to length(str) do str[i]:= Upcase(str[i]);

    buf_seg := seg(buf) + ofs(buf) div 16;
    buf_ofs := ofs(buf) mod 16;
    buf_ofs1 := buf_ofs + starting_at - 1;
    buf_ofs2 := buf_ofs + size;             {uppercase whole buffer}
    buf_Upcase := size- starting_at + 1;

    GETMEM(UC_buf, size);        { allocate space for UpperCase buffer}

    UC_buf_seg := seg(UC_buf^) + ofs(UC_buf^) div 16;
    UC_buf_ofs := (ofs(UC_buf^) mod 16);
    UC_buf_ofs1 := UC_buf_ofs + starting_at - 1;
    UC_buf_ofs2 := UC_buf_ofs + size - str_len;

    asm
          PUSH    DS             {save data segment}
          MOV     DS,BUF_SEG     { set-up DS,SI for real buffer}
          MOV     SI,BUF_OFS1
          MOV     DX,BUF_UPCASE       { dx equals end of real buffer}
          MOV     BX,0             { bx equals start of real buffer}
          MOV     ES,UC_BUF_SEG   {set-up ES,DI for new temporary buffer}
          MOV     DI,UC_BUF_OFS1


      @AGAIN2:
          MOV     al,DS:[BX+SI]  { get current character from real buffer}
          CMP     al,'a'
          JL      @NEXT1
          CMP     al,'z'
          JA      @NEXT1
          AND     al,0DFh        { convert to upper case by subtracting 32}
      @NEXT1:                    { jump directly here if not lowercase}
          MOV     ES:[BX+DI],al     { store character in new UC buffer}
          INC     BX
          CMP     BX,DX          { end of the buffer yet?}
          JLE     @AGAIN2
          POP     DS
    end;
    Search_buf_seg := UC_buf_seg;
    Search_buf_ofs := UC_buf_ofs;
  end
  else begin     { NOT case_insensitive then set Search_buf to real buffer}

      Search_buf_seg := seg(buf) + ofs(buf) div 16;
      Search_buf_ofs := ofs(buf) mod 16;
  end;


  {---following 2 assignments are the same for either type search---}

  Search_buf_ofs1 := Search_buf_ofs + starting_at - 1;
  Search_buf_ofs2 := Search_buf_ofs + size - str_len;

  asm
          PUSH    DS               { save data segment}
          MOV     DS,STR_SEG       {set up for CMPSB}
          MOV     ES,SEARCH_BUF_SEG
          MOV     SI,STR_OFS
          MOV     AX,SI            {save str_ofs for subsequent recall}
          MOV     DI,SEARCH_BUF_OFS1
          MOV     BX,DI            {save search_buf_ofs1 for recall}
          MOV     DX,SEARCH_BUF_OFS2
          MOV     CX,STR_LEN
    @AGAIN:
    REPE  CMPSB                 {compare the CX bytes at DS:[SI] & ES:[DI]}
          JE      @GOT_1
          INC     BX
          CMP     BX,DX         { end of buffer yet? }
          JG      @DONE
          MOV     SI,AX
          MOV     DI,BX
          MOV     CX,STR_LEN     { reset CX to str_len }
          JMP     @AGAIN

    @DONE:
          MOV     BX,SEARCH_BUF_OFS     {set up bx so that we return 0}
          DEC     BX

    @GOT_1:
          MOV     P,BX   {p is the search_buf_ofs where we found the string}
          POP     DS
  end;

  if case_insensitive then FREEMEM( UC_buf, size);
  pos_of := p - search_buf_ofs + 1;
end; {pos_of}

{----------------------------------------------------------------------}

function is_blank(s:string):boolean;
var
  i : byte;
  all_blank : boolean;
begin
  all_blank := true;
  i := length(s);
  while (i > 0) and all_blank do begin
    if s[i] <> ' ' then all_blank := false;
    dec(i);
  end;
  is_blank := all_blank;
end;

{----------------------------------------------------------------------}
function val2_of(d1,d2:char):word;
{returns a value of a 2 character string}
begin
  if not (d1 in ['0'..'9']) then d1 := '0';
  if not (d2 in ['0'..'9']) then d2 := '0';
  val2_of := (ord(d1)-48)*10 + ord(d2)-48;
end;

{----------------------------------------------------------------------}

function str2_of(i:word):string;
{returns a 2 character string representation of i}
begin
  str2_of := char(i div 10 mod 10 + ord('0')) + char(i mod 10 + ord('0'));
end;

{----------------------------------------------------------------------}

function d2(w:word):string;

{converts w to a two digit string with leading zeros.}

begin
  d2 := char(w div 10 + 48) + char(w mod 10 + 48);
end;

{----------------------------------------------------------------------}

function alt_key_is_pressed:boolean;
{1-right shift, 2-left shift, 4-ctrl, 8-alt, 16-scroll lock, 32-num lock}
{64-caps lock, 128-ins}
begin
  alt_key_is_pressed:= (mem[64:23] and 8) > 0;
  end; {alt_key_is_pressed}

{----------------------------------------------------------------------}

function max(i, j:integer):integer;
begin
  if i > j then max := i else max := j;
end;

{----------------------------------------------------------------------}

function min(i, j:integer):integer;
begin
  if i > j then min := j else min := i;
end;

{----------------------------------------------------------------------}

procedure beep;
var
  t : word;
begin

{ Because it requires the CRT unit, this version of beep does not use: }
{ sound(440);  }
{ delay(100);  }
{ nosound;     }

  {start sound}
  port[$43]:=$b6; {Set 8253 timer 2 to square wave and load freq}
                                       {freq = 1193181.7/count}
  port[$42]:=$00;                      {low byte of count}
  port[$42]:=$10;                      {hi  byte of count}
  port[$61]:=port[$61] or $03;         {turn speaker on}

  {delay for at least 1/18 sec.}
  t:=memw[$40:$6c];                    {ticks 18.2 times per sec}
  while memw[$40:$6c] = t do;          {wait for next tick}
  t:=memw[$40:$6c];
  while memw[$40:$6c] = t do;          {wait for one more tick}

  {stop sound}
  port[$61]:=$00;                      {turn speaker off}

  end; {beep}

{---------------------------------------------------------------------}

function current_time:time_type;

var
  yr, mo, day, hr, min, sec, sec100, dow : word;
  s : string[18];

begin

  GetTime(hr, min, sec, sec100);
  GetDate(yr, mo, day, dow);
  yr := yr mod 100;
  current_time := d2(hr) + ':' + d2(min) + dow_str[dow] +
       d2(mo) + '/' + d2(day) + '/' + d2(yr);
end;

{---------------------------------------------------------------------}

function current_tm:tm_type;

var
  yr, mo, day, hr, min, sec, sec100, dow : word;
  s : string[18];

begin

  GetTime(hr, min, sec, sec100);
  GetDate(yr, mo, day, dow);
  yr := yr mod 100;
  current_tm := d2(yr) + d2(mo) + d2(day) + d2(hr) + d2(min);
end;

{---------------------------------------------------------------------}

function tm_to_tmfld(tm:tm_type):tmfld_type;

begin
  tm_to_tmfld := copy(tm,7,4){hhmm} + copy(tm,3,4){mmdd} + copy(tm,1,2){yy};
end;

{---------------------------------------------------------------------}

function tm_to_time(tm:tm_type):time_type;

var
  yr, mo, day, hr, min, dow : word;
  s : string[18];

begin

  if is_blank(tm) then begin
    tm_to_time := '                  ';
  end
  else begin
    yr  := val2_of(tm[1], tm[2]);
    mo  := val2_of(tm[3], tm[4]);
    day := val2_of(tm[5], tm[6]);

    dow := d_to_j(mo,day,yr) mod 7;
    tm_to_time := tm[7] + tm[8] + ':' + tm[9] + tm[10] + dow_str[dow] +
         tm[3] + tm[4] + '/' + tm[5] + tm[6] + '/' + tm[1] + tm[2];
  end;
end;

{----------------------------------------------------------------------}

function tmfld_to_tm(tmfld:tmfld_type):tm_type;

begin
  tmfld_to_tm := copy(tmfld,9,2){yy} + copy(tmfld,5,4){mmdd} + copy(tmfld,1,4){hhmm};
end;

{----------------------------------------------------------------------}

function valid_tm(tm:tm_type):boolean;

var
  curr_tm :  tm_type;

begin
  {1234567890}
  {yymmddhhmm}

  if length(tm) <> 10 then tm := pad(tm,10);

  if (tm[1] = ' ') and (tm[2] = ' ') then begin
    curr_tm := current_tm;
    tm[1] := curr_tm[1];
    tm[2] := curr_tm[2];
  end;

  if (tm[3] = ' ') and (tm[4] = ' ') then begin
    curr_tm := current_tm;
    tm[3] := curr_tm[3];
    tm[4] := curr_tm[4];
  end;

  if (tm[1] = '9') and                  {tens yr}
     (tm[2] in ['3'..'9']) and          {unit yr}
     (tm[3] in [' ','0'..'1']) and      {tens mo}
     (tm[4] in ['0'..'9']) and          {unit mo}
     (tm[5] in [' ','0'..'3']) and      {tens day}
     (tm[6] in ['0'..'9']) and          {unit day}
     (tm[7] in [' ','0'..'2']) and      {tens hr}
     (tm[8] in ['0'..'9']) and          {unit hr}
     (tm[9] in [' ','0'..'5']) and      {tens min}
     (tm[10] in ['0'..'9'])             {unit min}
     then valid_tm := true
  else valid_tm := false

end;

{----------------------------------------------------------------------}
procedure get_password(var users_guess:string);
begin
  SAVESCREEN(3);
  read_password(25, 8, 15, ' Password ? ', 1, users_guess);
  if r_char <> Esc then users_guess := encrypt(users_guess);
  RESTORESCREEN(3);
  DISPOSESCREEN(3);
end;

{----------------------------------------------------------------------}
procedure get_new_password(var users_guess:string; var updated:boolean);
var
  guess_1, guess_2 : string;
begin
  SAVESCREEN(3);
  guess_1 := '';
  updated := false;
  read_password(25, 8, 15, ' New password ? ', 1, guess_1);
  if guess_1 <> '' then begin
    guess_2 := '';
    read_password(25, 8, 15, ' Please verify the new password. ', 1, guess_2);
    if guess_2 <> '' then begin
      if upper(trim(guess_1)) = upper(trim(guess_2)) then begin
        users_guess := encrypt(guess_1);
        updated := true;
      end
      else err_msg('Verify failed. Try again.');
    end;
  end;
  RESTORESCREEN(3);
  DISPOSESCREEN(3);
end;

{----------------------------------------------------------------------}

function encrypt(password:string):string;
var
  i : longint;
begin
  password := upper(trim(password));
  for i := 1 to length(password) do begin
    password[i] := char(7377*i mod 64 - 32 + ord(password[i]));
  end;
  encrypt := password;
end;
*)
{----------------------------------------------------------------------}

{julian date stuff}

{ Notes:                                                  }
{   j is number if days into century                      }
{   years divisible by 4 are leap years, 29 days in Feb.  }
{   except Feb. 1900 has 28 days                          }
{   1/1/1900 is a monday                                  }

const days_in_month : array[0..1,1..12] of integer =
     ((31,28,31,30,31,30,31,31,30,31,30,31),          {nonleap year}
      (31,29,31,30,31,30,31,31,30,31,30,31));         {leap year}

var
  offset : array[0..1,1..12] of integer;  {number of days to first of month}
  m : word;
  leap : byte;

function d_to_j(m,d,y:word):longint;
var
  j : longint;
  leap : byte;
begin
  if y = 0 then begin {1900 is not a leap year}
    j := offset[0,m] + d;
  end
  else begin {not 1900}
    if y mod 4 = 0 then leap := 1 else leap :=0;
    j := longint(365) * y + (y-1) div 4 + offset[leap,m] + d;
  end;
  d_to_j := j;
end;

procedure j_to_d(j:longint; var m,d,y : word);
var
  leap : byte;
begin
  if j < 366 then begin { it 1900, not a leap year}
    y := 0;
    leap := 0;
  end
  else begin
    j := j + 1; {fake out that 1900 is a leap year}
    y := (j * 4 - 4) div (365*4+1); { kind of like j / 365.25}
    if y mod 4 = 0 then leap := 1 else leap :=0;
  end;
  d := j - (longint(365)*y + (y+3) div 4);
  m := 1;
  while d > days_in_month[leap,m] do begin
    dec(d,  days_in_month[leap,m]);
    inc(m);
  end;
end;

function tm_to_tj(tm:tm_type):longint;
var
  yr, mo, day, hr, min : word;
  tj : longint;
begin
  if is_blank(tm) then begin
    tm_to_tj := 0;
  end
  else begin
    yr  := val2_of(tm[1], tm[2]);
    mo  := val2_of(tm[3], tm[4]);
    day := val2_of(tm[5], tm[6]);
    hr  := val2_of(tm[7], tm[8]);
    min := val2_of(tm[9], tm[10]);
    tm_to_tj := (d_to_j(mo,day,yr) * 24 + hr) * 60 + min;
  end;
end;

function tj_to_tm(tj:longint):tm_type;
var
  yr, mo, day, hr, min : word;
  j, tmp : longint;
begin
  if tj = 0 then begin
    tj_to_tm := '          ';
  end
  else begin
    min := tj mod 60;
    tmp := tj div 60;
    hr  := tmp mod 24;
    j   := tmp div 24;
    j_to_d(j,mo,day,yr);
    tj_to_tm := d2(yr) + d2(mo) + d2(day) + d2(hr) + d2(min);
  end;
end;

function mm_slash_dd_slash_yy_to_yymmdd(s:string):string;
var
  p1, p2 :byte;
begin
  p1  :=  pos('/', s);
  if p1 in [2,3] then begin
    s[p1] := ' ';
    if p1 = 2 then s := '0' + s;
    p2  :=  pos('/', s);
    if p2 in [5,6] then begin
      if p2 = 5 then insert('0', s, 4);
      mm_slash_dd_slash_yy_to_yymmdd := s[7] + s[8] + s[1] + s[2] + s[4] + s[5];
    end
    else mm_slash_dd_slash_yy_to_yymmdd := 'XXXXXX';
  end
  else mm_slash_dd_slash_yy_to_yymmdd := 'XXXXXX';
end;

{----------------------------------------------------------------------}

procedure display_month(m,y:word; var key_code:char);
const
  x0 = 23;
  y0 = 7;
const days_in_month : array[0..1,1..12] of integer =
     ((31,28,31,30,31,30,31,31,30,31,30,31),
      (31,29,31,30,31,30,31,31,30,31,30,31));

var
  d   : integer; {day of month,may be negative for row 1 of calendar}
  nd  : word; {days in m/y}
  dow : word; {day of week}
  dow1: word; {day of week of first of m/1/y}
  w   : word; {week number}
  nw  : word; {number of weeks in m/y}
  c   : char;
  dd  : string[2];
  j   : longint;    {julian date}

begin

  j := d_to_j(m,1,y);
  dow1 := j mod 7;
  if (y mod 4) = 0 then nd := days_in_month[1,m]
                   else nd := days_in_month[0,m];
  nw := (nd + dow1 + 6) div 7;

  d := 1 - integer(dow1);
  mkwin(x0-2, y0-2, x0 + 37, y0 + nw*2 + 5, MsgF, MsgB, 2);
  writecenter(y0 - 1, MsgF, MsgB, d2(m) + '/' + d2(y));
  plainwrite(x0,y0,        'Ŀ');
  plainwrite(x0,y0+1,      ' SU  MO  TU  WE  TH  FR  SA ');
  for w := 1 to nw do begin
    plainwrite(x0,y0+w*2,  'Ĵ');
    plainwrite(x0,y0+w*2+1,'');
    for dow := 0 to 6 do begin
      if (d < 1) or (d > nd) then dd := '  '
      else str(d:2,dd);
      plainwrite(x0+2+dow*5,y0+w*2+1,dd + ' ');
      inc(d);
    end;
  end;
  plainwrite(x0,y0+nw*2+2, '');

{  for i := 1 to n do PlainWrite(40 - l div 2, 7 + i, s[i]);}
  writecenter(y0 + nw*2 + 3, MsgF, MsgB, 'PgUp/PdDn - Prev/Next month');
  writecenter(y0 + nw*2 + 4, MsgF, MsgB, 'Any other key to exit');
  offcursor;
  key_code := getkey;
  oncursor;
  rmwin;
end;

{----------------------------------------------------------------------}

procedure display_calendar;

var
  y, m, d, dow : word;
  key_code : char;

begin
  GetDate(y,m,d,dow);
  y := y - 1900;
  repeat
    display_month(m,y,key_code);
    if key_code = PgUp then begin
      dec(m);
      if m = 0 then begin
        if y > 90 then dec(y);
        m := 12;
      end;
    end
    else if key_code = PgDn then begin
      inc(m);
      if m > 12 then begin
        if y < 99 then inc(y);
        m := 1;
      end;
    end;
  until not (key_code in [PgDn, PgUp, char(128)..char(131){mouse movement}]);
end;

{----------------------------------------------------------------------}

begin {unit initialization, julian date stuff}

  for leap := 0 to 1 do begin
    offset[leap,1] := 0;
    for m := 2 to 12 do begin
      offset[leap,m] := offset[leap,m-1] + days_in_month[leap,m-1];
    end;
  end;
  Set_Colors;
  display_calendar;
end. {end of on_util unit}

