program cdx;

uses dos, opdos;

var
  DirInfo: SearchRec;
  drive_let : char;
  subst_let : char;
  disk_class : diskclass;
  dir_spec : string;
  i : byte;

begin {main}
  writeln;
  dir_spec := paramstr(1);
  for i := 1 to length(dir_spec) do begin
    if dir_spec[i] = '/' then dir_spec[i] := '\';
  end;
  if dir_spec = '' then begin
    writeln('   CDX finds and changes to a specified directory.');
    writeln('   It automatically selects the correct drive.');
    writeln;
    writeln('   Syntax: CDX wild_spec');
    halt;
  end;
  drive_let := 'C';
  disk_class := GetDiskClass(drive_let, subst_let);
  while disk_class in [HardDisk, RamDisk] do begin
    FindFirst(drive_let+':'+dir_spec, Directory, DirInfo);
    while DosError = 0 do begin
      if DirInfo.attr = Directory then begin
        SelectDrive(drive_let);
        {strip end off dir_spec; incase there is a wild card}
        {$B-}
        while (length(dir_spec) > 0) and
              (dir_spec[length(dir_spec)] <> '\') do dec(byte(dir_spec[0]));
        {$i-}
        Chdir(dir_spec+DirInfo.name);
        {$i+}
        halt;
      end;
      FindNext(DirInfo);
    end;
    inc(byte(drive_let));
    disk_class := GetDiskClass(drive_let, subst_let);
  end;
  writeln('No directories meet the wild_spec = ',dir_spec);
end.
