program clip;
var
   in_name,out_name : string[80];
   in_file,out_file : file;
   buffer           : array [1..16384] of byte;
   recs             : integer;
   ch               : char;
   bytes_str        : string[12];
   bytes            : longint;
   start_str        : string[12];
   start            : longint;
   code             : integer;

function exists(var filename_of_any_string_length):boolean;
var
  filename : string[255] absolute filename_of_any_string_length;
  filein : text;
begin
  assign(filein,filename);
  {$I-}
  reset(filein);
  {$I+}
  if ioresult = 0 then begin
    exists:=true;
    close(filein);
    end
  else exists:=false;
  end; {exists}

begin

    if paramstr(4) = '' then begin
      writeln ('CLIP clips part of in_file and puts it in out_file.');
      writeln ('Usage: CLIP in_file out_file start_pos #_of_bytes_to_copy');
      halt;
      end;
    in_name :=paramstr(1);
    out_name:=paramstr(2);
    start_str  :=paramstr(3);
    bytes_str :=paramstr(4);
    val(start_str,start, code);
    if code <> 0 then begin
      WriteLn('ERROR: The third parameter, start position, is invalid.');
      WriteLn('       It should be in the range 1 to in_file size.');
      WriteLn('       Program terminating.');
      halt;
      end;
    val(bytes_str,bytes, code);
    if code <> 0 then begin
      WriteLn('ERROR: The fourth parameter, number of bytes to copy, is invalid.');
      WriteLn('       It should be in the range 1 to in_file size.');
      WriteLn('       Program terminating.');
      halt;
      end;
    if in_name = out_name then begin
      writeln;
      writeln('ERROR: You are attempting to copy a file onto itself.',
              '  Program terminating.');
      halt;
      end;
    if not exists(in_name) then begin
      writeln;
      writeln('ERROR: ',in_name,' does not exist.  Program terminating.');
      halt;
      end;
    if exists(out_name) then begin
      writeln;
      write('WARNING: ',out_name,' exists.  Do you want to copy over it? ');
      readln(ch);
      if upcase(ch) <> 'Y' then halt;
      end;
    assign (in_file,in_name);
    reset (in_file,1);
    assign (out_file,out_name);
    rewrite (out_file,1);
    {skip to start}
    seek(in_file,start-1);

    {copy bytes}
    repeat
      if bytes > 16384 then blockread (in_file,buffer,16384,recs)
      else blockread (in_file,buffer,bytes,recs);
      dec(bytes,recs);
      blockwrite (out_file,buffer,recs);
      until (bytes = 0) or (recs = 0);
    close (in_file);
    close (out_file);
   end.
