{$r+}
program cmpdir;

uses dos;

type
  dir_entry_type = record
    name : string[12];
    size : longint;
    time : longint;
    attr : byte;
    end;
  dir_entry_array = array[1..1050] of dir_entry_type;
  index_array = array[1..1050] of integer;

var
  dir_entry        : array[1..2] of dir_entry_array;
  dir_index        : array[1..2] of index_array;
  n_entries        : array[1..2] of integer;
  i                : integer;
  p                : array[1..2] of integer;

  d                : integer;
  dir_spec         : array[1..2] of string;
  arg_is_dir       : array[1..2] of boolean;
  finished_with_dir: array[1..2] of boolean;
  line_from_dir    : array[1..2] of string[80];
  show_common      : boolean;
  show_unique      : boolean;
  size             : string[80];
  unique_set       : set of 1..2;
  tmp_str          : string[80];

  unique_lines     : integer;
  common_lines     : integer;

procedure dir(wild_file_spec:string;
              var dir_entry:dir_entry_array; var n_entries:integer);

var
  s : searchrec;                {Turbo V4 p.403 search record}
  t:string[12];
  i,p_dot:integer;

begin {dir}
  if (ord(wild_file_spec[0]) = 0) then            { if nothing was entered}
     wild_file_spec :='????????.???';             { then use global search}
  if (pos('.',wild_file_spec)=0) and              { if no . and }
     (wild_file_spec[ord(wild_file_spec[0])]in['*','?']) { ends in * or ? }
     then wild_file_spec:=wild_file_spec+'.*';    { then add .* }
  if (wild_file_spec[ord(wild_file_spec[0])]=':') { if ends with : }
     then wild_file_spec:=wild_file_spec+'*.*';   { then add *.* }

  findfirst(wild_file_spec,$17,s);

  if ((s.attr and $10) > 0) and             {if we have a dir and}
     (pos('*',wild_file_spec) = 0) and
     (pos('?',wild_file_spec) = 0) and
     (doserror = 0) then begin
    wild_file_spec:=wild_file_spec+'/*.*';
    findfirst(wild_file_spec,7,s);
    end;

  while (s.name[1]='.') do findnext(s);     {skip subdirectories}

  n_entries:=0;
  while doserror = 0 do begin
    n_entries:=n_entries+1;
    dir_entry[n_entries].attr  :=s.attr;
    dir_entry[n_entries].time  :=s.time;
    dir_entry[n_entries].size  :=s.size;
    t:=s.name+'            ';
    t[0]:=chr(12);  {make length 12}
    p_dot:= pos('.',t);
    if p_dot > 0 then begin {put extension at end}
      t[12]:=t[p_dot+3];
      t[11]:=t[p_dot+2];
      t[10]:=t[p_dot+1];
      for i:=p_dot to 9 do t[i]:=' ';
      end;
    dir_entry[n_entries].name  :=t;
    findnext(s);
    end;
  end; {dir}

function gt(var x1,x2;size:integer):boolean;
var
  y1:array[1..maxint] of byte absolute x1;
  y2:array[1..maxint] of byte absolute x2;
  i:integer;
begin
  i:=2;
  while (y1[i]=y2[i]) and (i<size) do i:=i+1;
  gt:=y1[i]>y2[i];
{
write(i:5);
for i:=2 to 13 do write(chr(y1[i]));
for i:=2 to 13 do write(chr(y2[i]));
writeln(y1[i]>y2[i]:8);readln;
}
  end;

procedure shell_sort(var x:dir_entry_array;var index:index_array;n:integer);
var
  i,j:integer;
  d:integer;
  tmp:dir_entry_type;
begin
  for i:=1 to n do index[i]:=i;
  d:=1;
  while (d*2+1) < n do d:=d*2+1; {3,7,15,31,63...}
  repeat
    for i:=1 to n-d do begin
      j:=i;
      while j > 0 do begin
        if gt(x[index[j]],x[index[j+d]],28) then begin
          tmp:=x[index[j]];
          x[index[j]]:=x[index[j+d]];
          x[index[j+d]]:=tmp;
          j:=j-d;
          end
        else j:=0;
        end;
      end; {for i:=1 to n-1}
    d:=d div 2;
    until d = 0;
  end; {shell_sort}

procedure get_line_from_dir(d:integer);
var
  dt:datetime;
begin
  if p[d] <= n_entries[d] then begin
    {name}
    line_from_dir[d]:=dir_entry[d][dir_index[d][p[d]]].name;

    unpacktime(dir_entry[d][dir_index[d][p[d]]].time,dt);

    {size}
    str(dir_entry[d][dir_index[d][p[d]]].size:9,tmp_str);
    line_from_dir[d]:=line_from_dir[d]+tmp_str;
    {mo}
    str(dt.month:2,tmp_str);
    if tmp_str[1] = ' ' then tmp_str[1]:='0';
    line_from_dir[d]:=line_from_dir[d]+'  '+tmp_str;
    {day}
    str(dt.day:2,tmp_str);
    if tmp_str[1] = ' ' then tmp_str[1]:='0';
    line_from_dir[d]:=line_from_dir[d]+'/'+tmp_str;
    {year}
    str(dt.year:4,tmp_str);
    line_from_dir[d]:=line_from_dir[d]+'/'+tmp_str[3]+tmp_str[4];
    {hour}
    str(dt.hour:2,tmp_str);
    if tmp_str[1] = ' ' then tmp_str[1]:='0';
    line_from_dir[d]:=line_from_dir[d]+'  '+tmp_str;
    {min}
    str(dt.min:2,tmp_str);
    if tmp_str[1] = ' ' then tmp_str[1]:='0';
    line_from_dir[d]:=line_from_dir[d]+':'+tmp_str;

    p[d]:=p[d]+1;
    end
  else finished_with_dir[d]:=true;
  end;

  procedure error (err:integer;file_spec:string);

  begin {write error and exit}
    writeln;
    if err=1 then begin
      writeln ('ERROR: ',file_spec,' Not of Valid Format!');
      writeln;
      writeln ('         To store a dir in a file, use the following format:');
      writeln ('         DIR filespec1 > filespec2');
      end
    else writeln ('ERROR: Unable to Open ',file_spec);
    halt
  end;

  procedure dir_list_file (var file_spec:string;
                           var dir_entry_from_file:dir_entry_array;
                           var n_entries:integer);

  var
    f:text;
    dt:datetime;
    file_line:string[80];
    e:integer;
    yr:string[4];
    e_check:integer;
    counter:word;

  begin {translate dir from file}
    counter:=0;
    assign(f,file_spec);
{$I-}
    reset(f);
    if ioresult<>0 then error( 2,file_spec );
    readln( f,file_line );
    repeat {until the first line of the dir}
      inc(counter);
      readln( f,file_line );
      if ioresult<>0 then error( 1,file_spec );
      if copy( file_line,2,12 )='Directory of' then
        file_spec:=concat(copy( file_line,16,(17+pos( ' ',
                   copy( file_line,16,26)))),' as listed in ',file_spec);
      if counter>10 then error( 1,file_spec );
    until (file_line[1]<>' ') and (file_line[1]<>'.');
    n_entries:=0;
    e_check:=0;
    repeat {until no more dir entries}
      inc(n_entries,1);
      dir_entry_from_file[n_entries].name:=copy( file_line,1,12 );
      val( copy( file_line,13,9 ),dir_entry_from_file[n_entries].size,e );
      inc(e_check,e);
      val( copy( file_line,24,2 ),dt.month,e );
      inc(e_check,e);
      val( copy( file_line,27,2 ),dt.day,e );
      inc(e_check,e);
      val( concat('19',copy( file_line,30,2 )),dt.year,e );
      inc(e_check,e);
      if file_line[39]='p' then begin
        val( copy( file_line,34,2 ),dt.hour,e );
        inc(e_check,e);
        dt.hour:=dt.hour+12;
        if dt.hour=24 then dt.hour:=0;
        end
      else
        val( copy( file_line,34,2 ),dt.hour,e );
      inc(e_check,e);
      val( copy( file_line,37,2 ),dt.min,e);
      inc(e_check,e);
      dt.sec:=0;
      packtime(dt,dir_entry_from_file[n_entries].time);
      readln( f,file_line );
      if ioresult<>0 then error( 1,file_spec );
      if e_check<>0 then error( 1,file_spec );
    until (file_line='') or (file_line[1]=' ');
{$I+}
  end;

begin {main}

  writeln;
  writeln('Compare Directory Utility - Version 5.1');

  show_common:=false;
  show_unique:=true;
  unique_set:=[1,2];
  arg_is_dir[1]:=false;
  arg_is_dir[2]:=false;

  if (paramstr(1) = '') or (paramstr(1) = '?') then begin
    writeln;
    writeln('CMPDIR compares the entries of directories or wild card',
               ' file specifications.');
    writeln;
    writeln('  The format is : CMPDIR spec1 [spec2] [/U1] [/U2]',
            ' [/C] [/B] [/F1] [/F2]');
    writeln;
    writeln('  Square brackets denote optional arguments.');
    writeln('  spec1 and spec2 are specified exactly as in a DIR command.');
    writeln('  Example specs are: \PAS, A:, B:\BAT\CURRENT, *.DAT,',
            ' and DAY?.DAT .');
    writeln('  spec2 defaults to the current directory.');
    writeln;
    writeln('  The output, by default, will only list files unique to one of',
            ' the dir_specs.');
    writeln('    /U1 causes unique files dir1_spec to be listed.');
    writeln('    /U2 causes unique files dir2_spec to be listed.');
    writeln('    /C causes only the common files to be listed.');
    writeln('    /B causes both unique and common files to be listed.');
    writeln('    /F2 indicates spec1 is a file listing of a directory.');
    writeln('    /f2 indicates spec2 is a file listing of a directory.');
    writeln('  Examples:');
    writeln;
    writeln('    CMPDIR A: \SAMS     - Compares A: and \SAMS directory.');
    writeln('    CMPDIR *.DAT        - Does directory not including *.dat',
            ' files.');
    halt;
    end
  else begin
    dir_spec[1]:=paramstr(1);
    if (paramstr(2) <> '') and
       (pos('/',paramstr(2)) = 0) then dir_spec[2]:=paramstr(2)
    else getdir(0,dir_spec[2]);
    for i:=2 to paramcount do begin
      if (pos('/U1',paramstr(i)) > 0) or
         (pos('/u1',paramstr(i)) > 0) then begin
        show_unique:=true;
        unique_set:=[1];
        end;
      if (pos('/U2',paramstr(i)) > 0) or
         (pos('/u2',paramstr(i)) > 0) then begin
        show_unique:=true;
        unique_set:=[2];
        end;
      if (pos('/B',paramstr(i)) > 0) or
         (pos('/b',paramstr(i)) > 0) then begin
        show_common:=true;
        show_unique:=true;
        end;
      if (pos('/C',paramstr(i)) > 0) or
         (pos('/c',paramstr(i)) > 0) then begin
        show_common:=true;
        show_unique:=false;
        end;
      if (pos('/F1',paramstr(i)) > 0) or
         (pos('/f1',paramstr(i)) > 0) then begin
         arg_is_dir[1]:=true;
         end;
      if (pos('/F2',paramstr(i)) > 0) or
         (pos('/f2',paramstr(i)) > 0) then begin
         arg_is_dir[2]:=true;
      end; {for}
    end;

  unique_lines:=0;
  common_lines:=0;

  {get the directory infomation}
  for d:=1 to 2 do begin
    if arg_is_dir[d]
      then dir_list_file( dir_spec[d],dir_entry[d],n_entries[d] )
      else dir(dir_spec[d],dir_entry[d],n_entries[d]);
    shell_sort(dir_entry[d],dir_index[d],n_entries[d]);
    p[d]:=1;
    finished_with_dir[d]:=false;
    get_line_from_dir(d);
    if finished_with_dir[d] then begin
      writeln('No files in ',dir_spec[d]);
      writeln;
      end;
    end;

  {do the compare}

  if not finished_with_dir[1] or not finished_with_dir[2] then begin
    writeln;
    if arg_is_dir[1] then
      writeln('Comparison of ',dir_spec[1],', and ',dir_spec[2])
    else
      writeln('Comparison of ',dir_spec[1],' and ',dir_spec[2]);
    writeln;
    repeat
      if finished_with_dir[1] then begin
      repeat
        if show_unique and (2 in unique_set) then begin
          writeln(line_from_dir[2],' - Unique to ',dir_spec[2]);
          unique_lines:=unique_lines+1;
          end;
        get_line_from_dir(2);
        until finished_with_dir[2];
      end
    else if finished_with_dir[2] then begin
      repeat
        if show_unique and (1 in unique_set) then begin
          writeln(line_from_dir[1],' - Unique to ',dir_spec[1]);
          unique_lines:=unique_lines+1;
          end;
        get_line_from_dir(1);
        until finished_with_dir[1];
      end
    else if line_from_dir[1] = line_from_dir[2] then begin
      if show_common then writeln(line_from_dir[1],' - Common to both');
      common_lines:=common_lines+1;
      get_line_from_dir(1);
      get_line_from_dir(2);
      end
    else if line_from_dir[1] < line_from_dir[2] then begin
      if show_unique and (1 in unique_set) then begin
        writeln(line_from_dir[1],' - Unique to ',dir_spec[1]);
        unique_lines:=unique_lines+1;
        if copy(line_from_dir[1],1,13) = copy(line_from_dir[2],1,13) then begin
          writeln(' Note : Common file name - Different size/date/time.');
          end;
        end;
      get_line_from_dir(1);
      end
    else begin
      if show_unique and (2 in unique_set) then begin
        writeln(line_from_dir[2],' - Unique to ',dir_spec[2]);
        unique_lines:=unique_lines+1;
        if copy(line_from_dir[1],1,13) = copy(line_from_dir[2],1,13) then begin
          writeln(' Note : Common file name - Different size/date/time.');
          end;
        end;
      get_line_from_dir(2);
      end;
    until finished_with_dir[1] and finished_with_dir[2];
    end;
    if show_common and (common_lines=0) then writeln('No common files found.');
    if show_unique and (unique_lines=0) then writeln('No unique files found.');
  end;
  end.
