program count;

uses Dos;

var
  line : string;
  f1 : text;
  DirInfo: SearchRec;
  n_lines, n_words, tot_words, tot_lines, n_files, min_word_size : word;
  code : integer;
  D: DirStr;
  N: NameStr;
  E: ExtStr;

function word_count(s:string; min_word_size:word):word;
var
  i,n,start_i : word;
  in_word : boolean;
begin
  i := 0;
  n := 0;
  in_word := false;
  for i := 1 to length(s) do begin
    if s[i] = ' ' then begin
      if in_word then begin
        if i-start_i >= min_word_size then inc(n);
        in_word := false;
      end;
    end
    else begin {not at a blank}
      if not in_word then begin
        in_word := true;
        start_i := i;
      end;
    end;
  end;
  if in_word then begin
    if length(s)+1-start_i >= min_word_size then inc(n);
  end;
  word_count := n;
end;

begin
  if paramstr(1) = '' then begin
    writeln;
    writeln('  COUNT wild_file_spec [min_word_size]');
    writeln;
    writeln('    Counts number of lines and words in the specified files.');
    writeln('    Only works on text files (lines terminated with CR/LF).');
    writeln('    Default min_word_size is 3. Make min_word_size between 1 and 9.');
    halt;
  end;

  tot_lines := 0;
  tot_words := 0;
  n_files := 0;
  if (paramstr(2) < '1') or (paramstr(2) > '9') then min_word_size := 3
  else val(paramstr(2), min_word_size, code);

  FindFirst(paramstr(1), AnyFile, DirInfo);
  while DosError = 0 do begin
    n_lines := 0;
    n_words := 0;
    FSplit(paramstr(1), D, N, E);
    assign(f1,D + DirInfo.Name);
    reset(f1);
    repeat
      readln(f1, line);
      inc(n_words, word_count(line, min_word_size));
      inc(n_lines)
    until eof(f1);

    writeln(n_lines:8, ' lines and ', n_words:8, ' words in ',DirInfo.Name);
    close(f1);

    inc(tot_lines, n_lines);
    inc(tot_words, n_words);
    inc(n_files);

    FindNext(DirInfo);
  end;
  writeln('Files processed = ', n_files);
  writeln('Total lines     = ', tot_lines);
  writeln('Total words     = ', tot_words);
  if n_files > 0 then begin
    writeln('Average lines per file = ', 1.0 * tot_lines / n_files :4:2);
    writeln('Average words per file = ', 1.0 * tot_words / n_files :4:2);
    writeln('Average words per line = ', 1.0 * tot_words / tot_lines :4:2);
  end;
end.
