{todo:
d 12/11/95  put dirs at top and/or bottom via function larger
  add rename file key F2
  add move file       F4
d 12/11/95  add search          F5
d 12/11/95  add search again    F6
  let del key remove nonblank dirs OR prune dirs (VERY dangerous)
d 11/8/95  make d * work the same as d *.*
d 11/8/95  make sure drive letter is on front of file spec display, try d \dos
  make sure drive letter is on front of file spec display, try d tmp then dos
  add command line switches, e.g. /Name
d 11/2/95  RETURN TO THE SAME POSITION WHEN RETURNING TO A PARENT DIR
  add RED note that del w/o confirm is enabled
  fix junk screen problem
  update help window(s):
    esc exits to org dir
    enter exits to selected dir
}
{.$M $4000,0,$F000 }   { 16K stack & heap }
{$S-}
{$R-}
{$V-}
{.$D-}

Program D;

{$DEFINE DIRFULL}
                                                                           {}
Uses DOS,CRT,FastTTT5,WinTTT5,StrnTTT5,KeyTTT5,ReadTTT5,MiscTTT5;

type
  line_rec_ptr = ^line_rec;
  line_rec = record
    l       : string[78];
    next    : line_rec_ptr;
    prev    : line_rec_ptr;
  end;

Const
  DViewKey = #210;                                                        {}
  DViewStr: string[5] = 'Ins  ';                                          {}
  DRenameKey = #188;  {F2}
  DCopyKey = #189;    {F3}
  DMoveKey = #190;    {F4}
  DDelKey = #211;                                                         {}
  DDelStr: string[5] = 'Del  ';                                           {}
  DHelpKey = #187;                     {Alter these keys if desired.       }
  DHelpStr:string[2] = 'F1';           {Note: to disable these keys, set   }
  DToggleKey = #32;                    {      appropriate flags in Var D.   }
  DToggleStr: string[5] = 'Space';
  DZoomKey = #172;
{$IFDEF DIRFULL}
  DZoomStr: string[5] = 'Alt-Z';
  DJumpParentKey = #176;
  DJumpParentStr: string[5] = 'Alt-B';
  DChangeDirKey = #174;
  DChangeDirStr: string[5] = 'Alt-C';
  DSortOrderKey = #152;
  DSortOrderStr: string[5] = 'Alt-O';
  DSortSizeKey = #159;
  DSortSizeStr: string[5] = 'Alt-S';
  DSortNameKey = #177;
  DSortNameStr: string[5] = 'Alt-N';
  DSortExtKey = #146;
  DSortExtStr: string[5] = 'Alt-E';
  DSortTimeKey = #148;
  DSortTimeStr: string[5] = 'Alt-T';
  DSortDOSKey = #160;
  DSortDOSStr: string[5] = 'Alt-D';
  DToggleAskDELKey = #158;
  DToggleAskDELStr: string[5] = 'Alt-A';
  DSortDos  = 1;
  DSortName = 2;
  DSortExt  = 3;
  DSortSize = 4;
  DSortTime = 5;
  Ascending = 1;
  Descending = 2;
{$ENDIF}

Type
  DirDisplay = record
    TopX       : byte;
    TopY       : Byte;
    Rows       : byte;
    Attrib     : byte;
    BoxType    : byte;
    BoxFCol    : byte;
    BoxBCol    : byte;
    KeyFCol    : byte;
    BacCol     : byte;
    NorFCol    : byte;
    DirFCol    : byte;
    HiFCol     : byte;
    HiBCol     : byte;
    AllowEsc   : boolean;
    ShowDetails: boolean;
    Colswide   : byte;
    DisplayInfo: boolean;
    RestoreScreen : boolean;
    AllowHelp     : boolean;
    AllowToggle   : boolean;
    AllowZoom     : boolean;
    ZoomLine      : byte;
    AllowSort     : boolean;
    InitSort      : byte;
    Asc           : byte;
    AllowCD       : boolean;
    SelectDir     : boolean;
    AllowInput    : boolean;
    AskBeforeDEL  : boolean;
  end;

Var
  DTTT : DirDisplay;
  NoMemory : boolean;
  Scrn : pointer;
  Sc   : pointer;

Function Display_Directory(DIRFULLFileName: StrScreen;var Retcode:integer): StrScreen;
  forward;

Procedure Default_Settings;
  forward;

const
  max_remember = 20;
  n_remember : integer = 0;
var
  remember_path : array[1..max_remember] of strscreen;
  remember_file : array[1..max_remember] of strscreen;

Procedure remember(pathname : StrScreen; filename : StrScreen);
var
  i : integer;
begin
  i := 1;
  while (i <= n_remember) and (pathname <> remember_path[i]) do inc(i);
  if i > n_remember then begin
    if i <= max_remember then begin
      n_remember := i;
      remember_path[i] := pathname;
    end
    else i := 1;
  end;
  remember_file[i] := filename;
end;


Function Copy_File(SourceFile, TargetFile:StrScreen): byte;
{return codes:  0 successful
                1 source and target the same
                2 cannot open source
                3 unable to create target
                4 error during copy
}
var
  Source,
  Target : file;
  BRead,
  Bwrite : word;
  FileBuf  : array[1..20480] of char;
  Ftime : longint;
  CurrentDir : StrScreen;

begin
  If SourceFile = TargetFile then begin
    Copy_File := 1;
    exit;
  end;
  Assign(Source,SourceFile);
  {$I-}
  Reset(Source,1);
  {$I+}
  If IOResult <> 0 then begin
    Copy_File := 2;
    exit;
  end;

  Assign(Target,TargetFile);
  {$I-}
  Rewrite(Target,1);
  {$I+}
  If IOResult <> 0 then begin
    Copy_File := 3;
    exit;
  end;
  Repeat
    BlockRead(Source,FileBuf,SizeOf(FileBuf),BRead);
    BlockWrite(Target,FileBuf,Bread,Bwrite);
  Until (Bread = 0) or (Bread <> BWrite);
  If Bread <> Bwrite then Copy_File := 4
  else begin
    Copy_File := 0;
    getftime(Source,Ftime);
    setftime(Target,Ftime);
  end;
  Close(Source);
  Close(Target);
end; {of func Copy_File}

const
  bf = 1024;
  bytes_read : word = bf;
var
  buff : array [1..bf] of char;
  bfi : integer;

Procedure readline(var f:file;var line:string; size:integer);
var
  done  : boolean;
  ch    : char;
  lx    : integer;
begin
  lx := 0;
  done := false;
  line := '';
  repeat {getting chars into line until eol, line full or eof}
    {read(f, ch;}
    if bfi > bytes_read then begin {replenish buff}
      blockread(f, buff, bf, bytes_read);
      bfi := 1;
    end;
    done := bytes_read = 0;
    if not done then begin
      ch := buff[bfi];
      inc(bfi);
      done := ch = #10;
    end;
    if not done then begin
      if not(ch in [#13, ' '..'~']) then ch := '.';
      if ch <> #13 then begin
        {line := line + ch;}
        inc(lx);
        line[lx] := ch;
      end;
    end;
    if not done then begin
      done := lx = size;
    end;
  until done;
  line[0] := char(lx);
end;


procedure display_screen(tos:line_rec_ptr; var f:file);
var
  p : line_rec_ptr;
  i : integer;
begin
  ClearText(2,2,79,24,white,blue);
  if memavail < 4000 then begin
    WriteAt(12,12,red,white,' INSUFFICIENT MEMORY TO CONTINUE VIEWING; PRESS ESC ');
  end
  else begin
    p := tos;
    for i:= 2 to 24 do begin
      if p = nil then WriteAt(2,i,white,blue,'')
      else begin
        WriteAt(2,i,white,blue,p^.l);
        {set p to point to next line}
        if p^.next = nil then begin  {get another rec}
          if bytes_read = 0 then begin      {there is no more data}
            p := nil;
          end
          else begin
            new(p^.next);
            p^.next^.prev := p;
            p := p^.next;
            p^.next := nil;
            readline(f, p^.l, 78);
          end;
        end
        else p := p^.next;
      end;
    end;
  end;
end;

var
  search_string : string[80];

Procedure Search(var tos : line_rec_ptr; var f:file);
var
  found : boolean;
  key : char;
begin
  WRITEAT(33,10,CYAN,RED,'  SEARCHING  ');
  repeat
    found := pos(search_string, tos^.l) > 0;
    if not found then begin
      if tos^.next = nil then begin  {get another rec}
        if bytes_read = 0 then begin
          found := true; {not really found; we are at the last line}
        end
        else begin
          new(tos^.next);
          tos^.next^.prev := tos;
          tos := tos^.next;
          tos^.next := nil;
          readline(f, tos^.l, 78);
        end;
      end
      else tos := tos^.next;
    end;
    if keypressed then begin
      found := true;
      key := getkey;
    end;
  until found;
end;

Procedure ViewFile(file_name:StrScreen);
var
  tos, p    : line_rec_ptr;
  f         : file;
  i         : integer;
  line      : string[78];
  ch        : char;
begin
  assign(f,file_name);
  {$i-}
  reset(f,1);
  {$i+}
  if ioresult = 0 then begin
    MkWin(1,1,80,25,white,blue,1);
    WriteCenter(1,white,red,' Viewing '+file_name+ ' ');
    WriteCenter(25,white,red,' PgUp, PgDn, Up or Down arrow-Browse, F5-Search, F6-Search Again, Esc-Exit ');

    {make first line_rec}
    bfi := bf+1; {init buffer}
    new(p);
    readline(f, p^.l, 78);
    p^.next := nil;
    p^.prev := nil;
    tos := p;
    display_screen(tos, f);

    repeat
      ch := getkey;
      case ch of
        #201 : begin {PgUp}
          for i := 1 to 22 do begin
            if tos^.prev <> nil then tos := tos^.prev;
          end;
          display_screen(tos, f);
        end;
        #209 : begin {PgDn}
          for i := 1 to 22 do begin
            if tos^.next <> nil then tos := tos^.next;
          end;
          display_screen(tos, f);
        end;
        #200 : begin {Up arrow}
          if tos^.prev <> nil then begin
            tos := tos^.prev;
            display_screen(tos, f);
          end;
        end;
        #208 : begin {Down arrow}
          if tos^.next <> nil then tos := tos^.next;
          display_screen(tos, f);
        end;
        #191 : begin {F5 - Search}
          SaveScreen(1);
          search_string := '';
          Read_String(4,2,45,' Search string : ',1{BoxType}, search_string);
          RestoreScreen(1);
          DisposeScreen(1);
          if search_string <> '' then begin
            Search(tos, f);
            display_screen(tos, f);
          end;
        end;
        #192 : begin {F6 - Search again}
          if search_string <> '' then if tos^.next <> nil then begin
            tos := tos^.next;
            Search(tos, f);
            display_screen(tos, f);
          end;
        end;
      end;
    until ch in [#27, #210]; {Esc or Ins}

    {dispose of list}
    while tos^.prev <> nil do tos := tos^.prev;
    while tos^.next <> nil do begin
      tos := tos^.next;
      dispose(tos^.prev);
    end;
    dispose(tos);

    close(f);
    rmwin;
  end;
end;

Procedure Default_Settings;
begin
    With  DTTT  do
    begin
        TopX    := 0;
        TopY    := 0;
        Rows    := 0;
        AllowEsc := true;
        DTTT.AskBeforeDEL := true;
        Attrib := Readonly + Directory + Archive;
        BoxType := 1;
        ShowDetails := true;
        ColsWide := 5;
{$IFDEF DIRFULL}
        DisplayInfo := true;
        AllowHelp := true;
        AllowZoom   := true;
        ZoomLine := 25;
        AllowSort := true;
        InitSort := DSortName;     {sort in DOS order}
        AllowInput := True;
{$ELSE}
        DisplayInfo := false;
{$ENDIF}
        AllowCD := true;
        SelectDir := false;
        RestoreSCreen := true;
        AllowToggle := true;
        Asc := 1;
        BoxFCol := lightgray;
        BoxBCol := blue;
        KeyFCol := yellow;
        BacCol := black;
        NorFCol := white;
        DirFCol := yellow;
        HiFcol := black;
        HiBcol := cyan;
    end; {with}
end;



Function Display_Directory( DIRFULLFilename: StrScreen; var Retcode : integer): StrScreen;
{
              X1                                    X2
     Y1 >      _____________________________________
              |                                     | >
              |                                     | >  Infodepth
              |                                     | >
     Y2 >     |_____________________________________| >
              |                                     |
              |                                     |
              |                                     |
              |                                     |
              |                                     |
              |                                     |
     Y3 >     |_____________________________________|


          Retcodes >    0  -  filechosen
                        1  -  user escaped
                        2  -  not enough memory
                        3  -  no files matching
                        99 -  unexpected error

}
Type
  FRptr = ^FR;
  FR = record
            Name : string[8];
            Ext  : string[3];
            Size : longint;
            Time : longint;
            Attr : byte;
            Fn : integer;
            PrevFR: FRptr;
            NextFR : FRptr;
       end;

const
  OKCode = 0;           {ret codes}
  EscCode = 1;
  MemCode = 2;
  NofilesCode = 3;
  UnKnownCode = 99;
  InfoDepth = 4;        {no of lines in information box, i.e.Y1 to Y2}
  ReadMsg = 'Reading files';
  SortMsg = 'Sorting files';
  NoneMsg = 'No files ... ';
var
  X1,X2,Y1,Y2,Y3,R,Y3_Unzoomed : byte;{box dimensions}
  StartDir : StrScreen;      {default directory}
  ColumnsWide : byte;
  TopFn : integer;           {file number of top file in the display}
  BotFn : integer;           {file number of bottom file in the display}
  HiFn  : integer;           {file number of hilighted file}
  Zoomed: boolean;           {is file display extended to bottom of screen}
  ShowingDetails : boolean;
  PathName : StrScreen;      {the path section of filename}
  FileMask : StrScreen;
  FirstFile : FRptr;
  List_End : FRptr;
  ChosenFile: strscreen;
  TotalFiles: word;
  TotalDirs : word;
  TotalBytes: LongInt;
  Ftemp : FRPtr;
  HeapTop : pointer;
  DirTop : pointer;
  CursRec : array[1..4] of byte;
  SortOrder : byte;               {1-DOS, 2-Name, 3-Ext, 4-Size, 5-Time}
  SortAsc : boolean;

    Function Subdirectory(B : byte):boolean;
    begin
        Subdirectory := ( ( (B and Directory) = Directory) OR
                         ( (B and (Directory + Archive) = (Directory + Archive)  ) ) );
    end;

    Function FileAttribs(B:byte):StrScreen;
    var
      S : StrScreen;
    begin
        S := '    ';
        If ((B and ReadOnly) = Readonly) then
           S[1] := 'R';
        If ((B and Hidden) = Hidden) then
           S[2] := 'H';
        If ((B and SysFile) = SysFile) then
           S[3] := 'S';
        If ((B and Archive) = Archive) then
           S[4] := 'A';
        FileAttribs := S;
     end;

     Function LongFileDesc(F:FRptr):StrScreen;
     var
       DT :datetime;
       S  : StrScreen;
     begin
         If ShowingDetails then
         begin
             with F^ do
             begin
                 UnPackTime(Time,DT);
                 With DT do
                 begin
                     If Ext = '' then
                        S := Padleft(Name,12,' ')
                     else
                        S :=  Padleft(Name+'.'+Ext,12,' ');                 {start with name}
                     If Subdirectory(Attr) then                  {add file size}
                        S := S + Padright('<DIR>',8,' ')
                     else
                        S := S + Padright(Int_to_Str(Size),8,' ');
                     S := S + '    ';
                     Case Month of                               {add month}
                     1 : S := S + 'Jan ';
                     2 : S := S + 'Feb ';
                     3 : S := S + 'Mar ';
                     4 : S := S + 'Apr ';
                     5 : S := S + 'May ';
                     6 : S := S + 'Jun ';
                     7 : S := S + 'Jul ';
                     8 : S := S + 'Aug ';
                     9 : S := S + 'Sep ';
                     10: S := S + 'Oct ';
                     11: S := S + 'Nov ';
                     12: S := S + 'Dec ';
                     end;
                     S :=   S                                   {add the day,year}
                          + Padright(Int_to_Str(Day),2,'0')
                          + ','
                          + Int_to_Str(Year)
                          + '    ';
                     If Hour > 12 then                          {add a/p time}
                        S :=  S
                             +Padright(Int_to_Str(Hour-12),2,' ')
                             +':'
                             +Padright(Int_to_Str(Min),2,'0')
                             +'p'
                     else
                        S :=  S
                              +Padright(Int_to_Str(Hour),2,' ')
                              +':'
                              +Padright(Int_to_Str(Min),2,'0')
                              +'a';
                        S := S + '  '+FileAttribs(Attr);
                 end;   {with DT}
             end; {with F^}
         end
         else    {not one column}
          If F^.Ext = '' then
             S := Padleft(F^.Name,12,' ')
          else
             S := Padleft(F^.Name+'.'+F^.Ext,12,' ');
         LongFileDesc := S;
     end;

    Function PathSlash(S : StrScreen):StrScreen;
    begin
        If S[length(S)] <> '\' then
           S := S + '\';
        PathSlash := S;
    end;  {Sub Func PathSlash}

    Function PathNoSlash(S : StrScreen):StrScreen;
    begin
        If S[length(S)] = '\' then
           Delete(S,length(S),1);
        PathNoSlash := S;
    end;  {Sub Func PathSlash}

    Function PathParent(S : StrScreen):StrScreen;
    var P1 : byte;
    begin
        S := PathNoSlash(S);
        P1 := LastPos('\',S);
        PathParent := copy(S,1,P1);
    end;

    Function PathChild(S : StrScreen):StrScreen;
    begin
        PathChild := PathSlash(PathName + S);
    end;

    Procedure Extract_Path_Mask;
    var P1,P2 : byte;
    begin
        P1 := LastPos('\',DIRFULLFileName);
        P2 := Pos(':',DIRFULLFilename);
        If (P1 = 0) and (P2 = 0) then
        begin
            FileMask := DIRFULLFileName;
            PathName := PathSlash(StartDir);
            exit;
        end;
        If (P1 = length(DIRFULLFileName)) or
           (P2 = length(DIRFULLFileName)) then
        begin
            FileMask := '*.*';
            PathName := DIRFULLFileName;
            exit;
        end;
        If (P1 = 0) and (P2 = 2) then   { x:filename.ext}
        begin
           Filemask := copy(DIRFULLFileName,3,length(DIRFULLFileName));
           {$I-}
           GetDir(ord(upcase(DIRFULLFileName[1]))-64,PathName);
           {$I-}
           If IOResult <> 0 then
              PathName := PathSlash(StartDir)
           else
              PathName := PathSlash(PathName);
           exit;
        end;
        Filemask := copy(DIRFULLFileName,succ(P1),12);
        PathName := copy(DIRFULLFileName,1,P1);
    end;  {Extract_Path_Mask}

    Procedure LoadFiles(Mask:StrScreen;Attrib:byte);
    var
      Finfo : SearchRec;
      Recsize : word;

      Procedure PushOnHeap(var F:FrPtr);
      var P : byte;
      begin
          with F^ do
          begin
              Attr := Finfo.Attr;
              Time := Finfo.Time;
              Size := Finfo.Size;
              If FInfo.Name = '..' then
              begin
                  Name := '..';
                  Ext := '';
              end
              else
              begin
                  P := pos('.',Finfo.Name);
                  If P = 0 then
                  begin
                      Name := Finfo.Name;
                      Ext := '';
                 end
                 else
                 begin
                     Name := copy(FInfo.Name,1, pred(P));
                     Ext := copy(Finfo.Name,succ(P),3);
                 end;
              end;
              Fn := succ(TotalFiles);
              NextFR := nil;
              PrevFr := nil;
              TotalBytes := TotalBytes + Size;
          end;
          Inc(TotalFiles);
          If Finfo.Attr = Directory then
             Inc(TotalDirs);
      end;   {sub sub proc TransferFileToHeap}

      Procedure AllocHeap;
      begin
          If ( ( (Attrib = Directory) and (FInfo.Attr <> Directory) and
                ( Finfo.Attr <> Directory + Archive)  ) )then
             exit;   {if only looking for directory entries}
          If (Finfo.Name <> '.') and (DosError = 0) then
          begin
              If (TotalFiles = 0) then
              begin
                  PushOnHeap(FirstFile);
                  FirstFile^.PrevFR := nil;
                  Ftemp :=  FirstFile;
                  List_End := FirstFile;
              end
              else
              begin
                  GetMem(Ftemp^.NextFR,Recsize);
                  PushOnHeap(FTemp^.NextFr);
                  FTemp := Ftemp^.NextFR;
                  FTemp^.PrevFR := List_End;
                  List_End := Ftemp;
              end; {If TotalFiles = 0}
         end; { If name <> '.'}
      end;

    begin
        RecSize := Sizeof(FirstFile^);
        If MaxAvail < 2*Recsize then
        begin
            NoMemory := true;
            exit;
        end;
        Fastwrite(X1+2,Y2+1,attr(DTTT.NorFcol+blink,DTTT.BacCol),ReadMsg);
        FindFirst(PathName+Mask,Attrib,Finfo);
        If DosError <> 0 then
           exit;
        If TotalFiles = 0 then
        begin
           GetMem(FirstFile,RecSize);
           GetMem(List_End,RecSize);
        end;
        AllocHeap;
        While (DosError = 0) and (NoMemory = false) do
        begin
            If MaxAvail < RecSize then
               NoMemory := true
            else
            begin
                FindNext(Finfo);
                AllocHeap;
            end; {If MaxAvail}
        end; {while}
    end; {Sub Proc Loadfiles}

    Procedure Calculate_Box_Dimensions;
    var
      Boxwidth : byte;
    begin
        If ShowingDetails then
           Boxwidth := 54
        else
           Boxwidth := succ(DTTT.Colswide*14);
        with DTTT do
        begin
            If (TopX < 1) or (TopX > 80) then
               X1 :=  1 { (80 - Boxwidth) div 2  Scott}
            else
            begin
               If TopX <= (80 - Boxwidth) then
                  X1 := TopX
               else                               {move box left until it fits}
                  X1 := 80 - Boxwidth;
            end;
            X2 := X1 + Boxwidth;
            If Rows in [1..23] then
               R := Rows
            else
               R := 8;
            If (TopY < 1) or (TopY > DisplayLines - 2) then
               Y1 := 1
            else
               Y1 := TopY;
            If not DisplayInfo then
               Y2 := Y1
            else
            begin
                If Y1 + InfoDepth < DisplayLines - 2 then
                   Y2 := Y1 + InfoDepth
                else                               {no room for info}
                   Y2 := Y1;
            end;
            Y3 := Y2 + succ(R);
            If Y3 > DisplayLines then
            begin
               Y3 := DisplayLines;
               If Y2 <> Y1 then
               begin
                   Y2 := Y3 - succ(R);
                   Y1 := Y2 - InfoDepth;
               end
               else
               begin
                   Y2 := Y3 - succ(R);
                   Y1 := Y2;
               end;
            end;
        end;
    end;  {sub proc Calculate_Box_Dimensions}

    Procedure Display_Box;
    var
      LChar,Rchar : char;
      Col,
      I : integer;
    begin
        with DTTT do
        begin
            If Y2 = Y1 then
               ClearText(X1,Y1,X2,Y3,NorFCol,Baccol)
            else
            begin
                ClearText(X1,Y1,X2,pred(Y2),BoxFCol,BoxBcol);
                ClearText(X1,Y2,X2,Y3,NorFCol,Baccol);
            end;
            Col := attr(BoxFcol,BoxBCol);
            If (BoxType in [5..9]) then
            begin
                Box(X1,Y1,X2,Y3,BoxFcol,BoxBcol,Boxtype-5);
                If (X2 < 80) and (Y3 < DisplayLines) then
                begin
                    For I := succ(Y1) to succ(Y3) do
                        Fastwrite(succ(X2),I,ShadColor,chr(219));
                    Fastwrite(succ(X1),succ(Y3),ShadColor,replicate(X2-X1,chr(219)));
                end;
            end
            else
               Box(X1,Y1,X2,Y3,BoxFcol,BoxBcol,Boxtype);
            If Y2 > Y1 then
            begin
                Horizline(succ(X1),pred(X2),Y2,BoxFCol,BoxBcol,Boxtype);
                Case Boxtype of
                1,6 : begin
                          LChar := chr(195);
                          RChar := chr(180);
                      end;
                2,7 : begin
                          LChar := chr(204);
                          RChar := chr(185);
                      end;
                3,8 : begin
                          LChar := chr(199);
                          RChar := chr(182);
                      end;
                4,9 : begin
                          LChar := chr(181);
                          RChar := chr(198);
                      end;
                else      Lchar := ' ';
                          Rchar := ' ';
                end;  {case}
                Fastwrite(X1,Y2,Col,Lchar);
                Fastwrite(X2,Y2,Col,Rchar);
            end;
{            Fastwrite (Y1,BoxFCol,BoxBcol,' D : The Directory Management Tool '); }
{            Fastwrite (Y3,BoxFCol,BoxBcol,' F3:Copy Del:Del Ins:View ');           }
            Fastwrite (X1+10,Y1,attr(BoxFCol,BoxBcol),' D : The Directory Management Tool ');
            Fastwrite (X1+15,Y3,attr(BoxFCol,BoxBcol),' F3:Copy Del:Del Ins:View ');
        end;
    end;  {sub proc display box}

    Procedure DisplayPath;
    var
       L : byte;
       Y : byte;
       P : StrScreen;
    begin
        P := Pathname+Filemask;
        L := length(P);
        If Y2 = Y1 then
        begin
           Y := Y1;
           If L > (X2-X1-2) then
              P := chr(17)+copy(P,L-(X2-X1)+4,L);
        end
        else
        begin
           Y := Y1 + 2;
           If L > (X2-X1-2) then
              P := chr(17)+copy(P,L-(X2-X1-1)+4,L);
        end;
        Fastwrite(X1+2,Y,attr(DTTT.BoxFcol,DTTT.BoxBCol),P);
    end;  {sub Proc DisplayPath}


    Procedure FillInfo;
    var
      TB,Di,FB : StrScreen;
      C,H,L  : byte;
    begin
        with DTTT do
        begin
            C := attr(BoxFCol,BoxBCol);
            H := attr(KeyFcol,BoxBCol);
            If (Y2 = Y1) then
            begin
                DisplayPath;
                exit;
            end;
{$IFDEF DIRFULL}
            If  (ColumnsWide < 3 ) and (ShowingDetails = false) then
            begin
                DisplayPath;
                Fastwrite(X1+2,Y1+1,H,'Esc');
                Fastwrite(X1+6,Y1+1,C,'Exit');
                Fastwrite(X1+2,Y1+3,C,'Files: ');
                Fastwrite(X1+9,Y1+3,C,Int_To_Str(TotalFiles-TotalDirs));
                exit;
            end;
            ClearText(succ(X1),Succ(Y1),pred(X2),Pred(Y2),BoxFcol,BoxBCol);
            Fastwrite(X1 + 2,Y1 + 3,C,'Matching files: ');
            Fastwrite(X1 + 18,Y1 + 3,C,Int_To_Str(TotalFiles-TotalDirs));
            TB := 'Total bytes: '+Int_To_Str(TotalBytes);
            Fastwrite(X2 -length(TB) - 1,Y1 + 3,C,TB);
            FB := 'Avail bytes: '+Int_to_Str(diskfree(ord(pathname[1])-64) );
            Fastwrite(X2 -length(FB) - 1,Y1 + 2,C,FB);
            If AllowHelp then
            begin
                Fastwrite(X1+2,Y1+1,H,DHelpStr);    {Prompt at left}
                Fastwrite(X1+3+length(DHelpStr),Y1+1,C,'Help');
            end;
            L := pred(X1)
               + ((X2-X1) div 2)
               - (length(DToggleStr)+ 7) div 2;     {next prompt in center}
            Fastwrite(L,Y1+1,H,'Esc');
            L := L + 4;
            Fastwrite(L,Y1+1,C,'Exit');
            If AllowToggle then
            begin
                L := X2 - length(DToggleStr) - 8;   {right justified}
                Fastwrite(L,Y1+1,H,DToggleStr);
                L := L + 1 + length(DToggleStr);
                Fastwrite(L,Y1+1,C,'Toggle');
            end;
        end;
        DisplayPath;
{$ELSE}
       end;
{$ENDIF}
    end;  {sub proc Fillinfo}

    Function FilePointer(Fn:word): FRptr;
    {MODIFY to go from current pointer - for speed}
    var
      P : FRptr;
      I : integer;
    begin
        If  SortAsc then
        begin
            P := FirstFile;
            If Fn > 1 then
               For I := 2 to Fn do
                   P := P^.NextFr;
        end
        else {Descending}
        begin
            P := List_End;
            If Fn > 1 then
               For I := 2 to Fn do
                   P := P^.PrevFr;
        end;
        FilePointer := P;
    end;  {sub proc filepointer}

    Function Y_Coord(Fn : word):byte;
    begin
         Y_Coord := Succ(Y2) + ((Fn-TopFn) DIV ColumnsWide);
    end;

    Function X_Coord(Fn : word):byte;
    begin
           X_Coord := succ(X1) + 14*((Fn-TopFn) MOD Columnswide);
    end;

    Function TopLine:Boolean;
    begin
          TopLine := (HiFn <= ColumnsWide);
    end;

    Function BottomLine:Boolean;
    begin
          BottomLine := (HiFn + ColumnsWide > TotalFiles);
    end;

    Function FirstColumn:boolean;
    begin
           If Columnswide = 1 then
              FirstColumn := true
           else
              FirstColumn := (HiFn MOD ColumnsWide = 1);
    end;

    Function LastColumn:boolean;
    begin
           LastColumn := (HiFn MOD ColumnsWide = 0);
    end;

    Procedure RecalcTopFn;
    begin
        If ColumnsWide = 1 then
           TopFn := succ(BotFn -R)
        else
            TopFn :=  Succ(   BotFn
                            - pred(R)*ColumnsWide
                            - BotFn MOD ColumnsWide
                          );
    end;

    Procedure RecalcBotFn;
    begin
        BotFn := pred( TopFn + ColumnsWide*R);
        If BotFn > TotalFiles then
           BotFn := TotalFiles;
    end;

    Procedure LolightFile(Fn:word);
    var
      C : byte;
      F : FRptr;
    begin
        If (Fn < TopFn) or (Fn > BotFn ) then
           exit;    {file not in display area}
        F := Filepointer(Fn);
        If Subdirectory(F^.Attr) then
           C := attr(DTTT.DirFcol,DTTT.BacCol)
        else
           C := attr(DTTT.NorFCol,DTTT.BacCol);
        Fastwrite(X_Coord(Fn),
                  Y_Coord(Fn),
                  C,
                  ' '+LongFileDesc(F)+' ');
    end;

    Procedure HilightFile(Fn:word);
    var
      F : FRptr;
    begin
        If (Fn < TopFn) or (Fn > BotFn) then
           exit;    {file not in display area}
        F := Filepointer(Fn);
        Fastwrite(X_Coord(Fn),
                  Y_Coord(Fn),
                  attr(DTTT.HiFcol,DTTT.HiBCol),
                  +' '+LongFileDesc(F)+' ')
    end;

    Function File_name(Fn : word):StrScreen;
    var
       F : FRPtr;
       Fname : strscreen;
    begin
        F := FilePointer(Fn);
        Fname := F^.Name;
        If F^.Ext <> '' then
           Fname := Fname+'.'+F^.Ext;
        File_Name := Fname;
    end;   {Sub Funct File_name}

    Procedure DisplayFiles;
    var
      I : integer;
    begin
        If (Columnswide > 1) and (BotFn = TotalFiles) then    {clear line}
           ClearText(succ(X1),pred(Y3),Pred(X2),pred(Y3),DTTT.NorFcol,DTTT.BacCol);
        For I := TopFn to BotFn do
            If (I <> HiFn) and (I <= TotalFiles) then
               LolightFile(I);
        HiLightFile(HiFn);
    end; {sub proc DisplayFiles}

    Procedure Scroll_Down;
    begin
        TopFn := TopFn + Columnswide;
        RecalcBotFn;
        DisplayFiles;
    end; {scroll_down}

    Procedure Scroll_Up;
    begin
        TopFn := TopFn - Columnswide;
        RecalcBotFn;
        DisplayFiles;
    end; {scroll_up}

    Procedure Scroll_Top;
    begin
        TopFn := 1;
        RecalcBotFn;
        HiFn := 1;
        DisplayFiles;
    end; {scroll_Home}

    Procedure Scroll_Bottom;
    begin
        TopFn := succ(TotalFiles - R);
        BotFn := TotalFiles;
        HiFn := TotalFiles;
        DisplayFiles;
    end; {scroll_Home}


{\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\    SORTING   \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\}
{$IFDEF DIRFULL}

Function Larger(Ptr1,Ptr2: FRptr) : boolean;
var
  N1,N2 : string[8];
  E1,E2 : string[8];
  sub1, sub2 : boolean;
begin
  sub1 := Subdirectory(Ptr1^.Attr);
  sub2 := Subdirectory(Ptr2^.Attr);
  if sub1 and not sub2 then Larger := true
  else if not sub1 and sub2 then Larger := false
  else Case SortOrder of
    DSortDos : Larger := (Ptr1^.Fn > Ptr2^.Fn);
    DSortNAME  : If Ptr1^.Name = Ptr2^.Name then
                    Larger := Ptr1^.Ext > Ptr2^.Ext
                 else
                    Larger := Ptr1^.Name > Ptr2^.Name;
    DSortEXT   : If Ptr1^.Ext = Ptr2^.Ext then
                    Larger := Ptr1^.Name > Ptr2^.Name
                 else
                    Larger := Ptr1^.Ext > Ptr2^.Ext;
    DSortSIZE  : Larger := (Ptr1^.Size > Ptr2^.Size);
    DSortTIME  : Larger := (Ptr1^.Time > Ptr2^.Time);
    else Larger := false;
  end; {Case}
end; {suc proc larger}

Procedure SwapIt(var Ptr1,Ptr2: FRPtr);
var
   Temp : FR;
   Size : integer;
begin
    Temp := Ptr2^;
    Size := sizeof(Temp) - 8;
    Move(Ptr1^,Ptr2^,Size);
    Move(Temp,Ptr1^,Size);
end;  {sub proc Swap}

Procedure ShellSort;
var
   I,J,Delta : longint;
   Swapped : boolean;
   Ptr1,Ptr2 : FRPtr;

begin
    Delta := TotalFiles div 2;
    repeat
         Repeat
              Swapped := false;
              Ptr1 := FirstFile;
              Ptr2 := Ptr1;
              For I := 1 to Delta do
                  Ptr2 := Ptr2^.NextFr;
              For I := 1 to TotalFiles - Delta do
              begin
                  If I > 1 then
                  begin
                      Ptr1 := Ptr1^.NextFr;
                      Ptr2 := Ptr2^.NextFr;
                  end;
                  If Larger(Ptr1,Ptr2) then
                  begin
                      SwapIt(Ptr1,Ptr2);
                      Swapped := true;
                  end;
              end;
         Until (not Swapped);
         Delta := delta div 2;
    Until Delta = 0;
end;

				Procedure ReSort;
				begin
			    	ClearText(succ(X1),Succ(Y2),pred(X2),pred(Y3),DTTT.NorFcol,DTTT.BacCol);
			    	Fastwrite(X1 + 2,succ(Y2),attr(DTTT.NorFcol+blink,DTTT.BacCol),SortMsg);
			    	ShellSort;
			    	TopFn := 1;
			    	HiFn := 1;
			    	RecalcBotFn;
			    	DisplayFiles;
				end;
{$ENDIF}

    Procedure DisplayNewDirectory;
    var A : byte;
      i : integer;
      filename : StrScreen;
    begin
        A := DTTT.attrib and (AnyFile - VolumeID);
        Display_Box;
        TotalFiles := 0;
        TotalBytes := 0;
        TotalDirs  := 0;
        Mark(DirTop);
        If DTTT.AllowCd or DTTT.SelectDir then
        begin
            If Subdirectory(A) then
            begin
                 LoadFiles('*.*',Directory);                {load directory details first}
                 Loadfiles(Filemask,A and (anyfile - Directory));  {then load other files with mask}
            end
            else
                 LoadFiles(Filemask,A and (Anyfile - Directory));
        end
        else                  {automatically removed directory type files}
             LoadFiles(Filemask,A and (anyfile - Directory));
        FillInfo;
{$IFDEF DIRFULL}
        If SortOrder <> DSortDOS then
           ShellSort;
{$ENDIF}
        If TotalFiles = 0 then
           Fastwrite(X1+2,Y2+1,attr(DTTT.NorFcol,DTTT.BacCol),NoneMsg)
        else
          {have we been in this dir before?}
          filename := '';
          for i := 1 to n_remember do begin
            if remember_path[i] = PathName then filename := remember_file[i];
          end;
          if filename = '' then begin
            TopFn := 1;
            RecalcBotFn;
            HiFn := 1;
          end
          else begin
            {find last name we were at}
            HiFn := TotalFiles;
            while (HiFn > 1) and (file_name(HiFn) <> filename) do dec(HiFn);
            if HiFn < 10 then TopFn := 1 else TopFn := HiFn-10;
            RecalcBotFn;
          end;
          DisplayFiles;
    end;  {sub proc DisplayNewDirectory}

{$IFDEF DIRFULL}
    Procedure ShowNextLine (var X,Y :byte; Key,Description : string );
    Begin
            Inc (Y);
            Fastwrite(X+1,Y,attr(DTTT.KeyFCol,DTTT.BoxBCol),Key);
            Fastwrite(X+4+length(Key),Y,
                      attr(DTTT.BoxFCol,DTTT.BoxBCol),
                      Description);
    end;
    Procedure ShowHelpScreen;
    const
        width = 25;
        depth = 18;
    var
      Str : StrScreen;
      S  : word;
      Sc : pointer;
      X,Y : byte;
      ChH : char;
    begin
        If X1 + width > 80 then
           X := pred((80 - width) div 2)
        else
           X := X1+55;
        If Y1 + Depth > DisplayLines then
           Y := pred((DisplayLines -Depth) div 2)
        else
           Y := Y1;
        S := 160*DisplayLines;
        If MaxAvail < S then
           exit;
{        GetMem(Sc,S);
        MoveFromScreen(BaseOfScreen^,Sc^,S Div 2); }
        FBox(X,Y,pred(X+width),pred(Y+Depth),DTTT.BoxFCol,DTTT.BoxBCol,1);
        Case SortOrder of
        DSortDos  : Str := ' DOS';
        DSortName : Str := ' NAME';
        DSortExt  : Str := ' EXT';
        DSortSize : Str := ' SIZE';
        DSortTime : Str := ' TIME';
        end; {case}
{        If SortAsc then
           Str := Str +' in ASCENDING order'
        else
           Str := Str +' in DESCENDING order';
        If Zoomed then
           Str := Str +' (Zoomed) '
        else
           Str := Str+' (not zoomed) ';
        Str := ' Current: '+Str;
        WriteBetween(X,X + Width,pred(Y)+depth,DTTT.KeyFCol,DTTT.BoxBCol,Str); }
        If DTTT.AllowSort then
        begin
            ShowNextLine(X,Y,DsortDOSStr,'Dos order');
            ShowNextLine(X,Y,DsortNameStr,'Name');
            ShowNextLine(X,Y,DsortExtStr,'Extension');
            ShowNextLine(X,Y,DSortSizeStr,'Size');
            ShowNextLine(X,Y,DSortTimeStr,'Date/Time');
            ShowNextLine(X,Y,DSortOrderStr,'Ascend/descend');
        end
        else
           WriteBetween(X,X+Width,Y+3,DTTT.BoxFCol,DTTT.BoxBCol,'SORTING DISABLED');

            ShowNextLine(X,Y,DToggleAskDELStr,'Ask DEL toggle');
{            ShowNextLine(X,Y,'F2   ', 'Rename');}
            ShowNextLine(X,Y,'F3   ', 'Copy');
{            ShowNextLine(X,Y,'F4   ', 'Move');}
            ShowNextLine(X,Y,DViewStr,'View');
            ShowNextLine(X,Y,DDelStr,'Delete');
        If DTTT.AllowCD then
        begin
            ShowNextLine(X,Y,DChangeDirStr,'Change Drv/Dir');
            ShowNextLine(X,Y,DJumpParentStr,'CD ..');
        end;
{        WriteBetween(X, X + Width, Y,
                     DTTT.BoxFCol, DTTT.BoxBCol,
                     ' press any key ... ');

        ChH := upcase(GetKey);
        MoveToScreen(Sc^,BaseOfScreen^, S Div 2);
        FreeMem(Sc,S);                                       }
    end;
    Procedure PromptForDirectory;
    const
       width = 55;
    var
       S : word;
       Sc : pointer;
       X : byte;
       OldP,OldM,Strng,CurrentDIR : String;
    begin
        S := 160*DisplayLines;
        If MaxAvail < S then
           exit;
        OldP := Pathname;
        OldM := FileMask;
        GetMem(Sc,S);
        MoveFromScreen(BaseOfScreen^,Sc^,S Div 2);    {SaveThescreen}
        If X1 + width > 80 then
           X := pred((80 - width) div 2)
        else
           X := X1;
        FBox(X,Y1,pred(X + width),Y1 + 2,DTTT.BoxFCol,DTTT.BoxBCol,2);
        WriteBetween(X,X+Width,Y1,DTTT.KeyFCol,DTTT.BoxBCol,'  Directory of Files  ');
        Strng := PathName+FileMask;
        Read_String_Upper(X+1,Y1+1,width - 2,'',0,Strng);

        if( (Length(Strng)=POS(':',Strng))  OR
             (Length(Strng)=Lastpos('\',Strng)) )Then begin
           GetDir(ord(Strng[1])-64,Strng);
           Strng := Strng + '\*.*'
        end
        else begin
  GetDir(0,CurrentDir); { 0 = Current drive }
  {$I-}
  ChDir(Strng);
  if IOResult = 0 then
     Strng:=Strng + '\*.*';
  {$I+}
  ChDir(CurrentDir);
  end;
        MoveToScreen(Sc^,BaseOfScreen^, S Div 2);
        FreeMem(Sc,S);
        If (R_Char <> #027) then
        begin
            DIRFULLFileName := Strng;
            Extract_Path_Mask;
            Release(DirTop);
            DisplayNewDirectory;
            If TotalFiles = 0 then   {re-read original directory}
            begin
               sound(800);delay(200);nosound;
               PathName := OldP;
               FileMask := OldM;
               Release(DirTop);
               DisplayNewDirectory;
            end;
        end;
    end;

    Function PromptForFilename(C:char):string;
    const
       width = 55;
    var
       S : word;
       Sc : pointer;
       X : byte;
       Strng : String;
       Msg : Strscreen;
    begin
        S := 160*DisplayLines;
        If MaxAvail < S then
           exit;
        GetMem(Sc,S);
        MoveFromScreen(BaseOfScreen^,Sc^,S Div 2);    {SaveThescreen}
        If X1 + width > 80 then
           X := pred((80 - width) div 2)
        else
           X := X1;
        FBox(X,Y1,pred(X + width),Y1 + 2,DTTT.BoxFCol,DTTT.BoxBCol,2);
        If C = #0 then
        begin
           Msg := '  No files  - enter filename  ';
           Strng := '';
        end
        else
        begin
           Msg := '  Enter filename (or Esc)  ';
           Strng := C;
        end;
        WriteBetween(X,X+Width,Y1,DTTT.KeyFCol,DTTT.BoxBCol,Msg);
        Read_String_Upper(X+1,Y1+1,width-2,'',0,Strng);
        MoveToScreen(Sc^,BaseOfScreen^, S Div 2);
        FreeMem(Sc,S);
        If (R_Char <> #027) then
            PromptForFilename := Strng
        else
            PromptForFilename := '';
    end;

{$ENDIF}

{\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\}
{$IFDEF DIRFULL}
     Function No_Files_Found: integer;
     {returns 99 if user escaped
           or 0  if user enter a file
     }
     begin

       ChosenFile := PromptForFilename(#0);
       If ChosenFile = '' then
       begin
           No_Files_Found := 99;
           exit;
       end;
       If (pos('*',ChosenFile) > 0) or
          (pos('?',ChosenFile) > 0) or
          (ChosenFile[Length(ChosenFile)] = '\') or
          (ChosenFile[Length(ChosenFile)] = ':') then begin
         DIRFULLFileName := ChosenFile;
         Extract_Path_Mask;
         Release(DirTop);
         DisplayNewDirectory;
       end
       else begin
         If  (pos('\',ChosenFile) = 0) and
             (pos(':',ChosenFile) = 0) then begin
           ChosenFile := PathName + ChosenFile;
           No_Files_Found := 0;
           exit;
         end;
       end;
       No_Files_Found := 1;
     end; {of func No_Files_Found}
{$ENDIF}

Procedure RenameFile;
var
  full_file_name : string;
  save_name  : string[8];
  save_ext   : string[3];
  save_TopFn : integer;
  save_BotFn : integer;
  p : FRptr;
  dest : string;
  CurrentDir : string;
  ch : char;
  OK : boolean;
  copy_code : byte;
begin
  p := Filepointer(HiFn);
  full_file_name := PathNoslash(Pathchild(File_Name(HiFn)));
  dest := '';
  SaveScreen(1);
  Read_String_Upper(4,2,45,' Rename '+full_file_name+' to : ',1{BoxType},dest);
  if (pos('\',dest) + pos(':',dest) > 0) then ;

  GetDir(0,CurrentDir); { 0 = Current drive }
  RestoreScreen(1);
  DisposeScreen(1);
  {TBA}
end;

Procedure MoveFile;
begin
end;

Procedure Search;
begin
end;

Procedure SearchAgain;
begin
end;

Procedure CopyFile;
var
  full_file_name : string;
  save_name  : string[8];
  save_ext   : string[3];
  save_TopFn : integer;
  save_BotFn : integer;
  p : FRptr;
  dest : string;
  CurrentDir : string;
  ch : char;
  OK : boolean;
  copy_code : byte;
begin
  p := Filepointer(HiFn);
  If not Subdirectory(p^.Attr) then begin
    full_file_name := PathNoslash(Pathchild(File_Name(HiFn)));
    dest := '';
    SaveScreen(1);
    Read_String_Upper(4,2,45,' Copy '+full_file_name+' to : ',1{BoxType},dest);
    if (pos('\',dest) = 0) and  (pos(':',dest) = 0) then dest := PathName + dest;

    GetDir(0,CurrentDir); { 0 = Current drive }

    { Scott : Fix here for copying to C: }
    if(Length(Dest)=POS(':',Dest) )Then
       Dest:=Dest + COPY(Full_file_name,LastPos('\',Full_file_name)+1,12);

    {$I-}
    ChDir(Dest);
    if IOResult = 0 then
       Dest:=Dest + '\' +
              COPY(Full_file_name,LastPos('\',Full_file_name)+1,12);
    {$I+}
    ChDir(CurrentDir);

    RestoreScreen(1);
    DisposeScreen(1);
    If (R_Char <> #027) then begin
      if exist(dest) then begin
        TempMessageBoxCh(25, 2, yellow, red, 1, dest+' exists! Copy over it? (Y/N)', ch);
        OK := upcase(ch) = 'Y';
      end
      else OK := true;
      if OK then begin {do copy}
        copy_code := copy_file(full_file_name, dest);
        if copy_code = 1 then begin
          TempMessageBox(20, 3, yellow, red, 1, ' ERROR : File not copied. Source = Target.');
        end
        else if copy_code = 2 then begin
          TempMessageBox(20, 3, yellow, red, 1, ' ERROR : File not copied. Cannot open source.');
        end
        else if copy_code = 3 then begin
          TempMessageBox(20, 3, yellow, red, 1, ' ERROR : File not copied. Cannot create '+dest);
        end
        else begin {update screen; the copied file may be on it.}
          p := FilePointer(HiFn);
          save_name := p^.name;
          save_ext  := p^.ext;
          save_TopFn := TopFn;
          save_BotFn := BotFn;
          Release(DirTop);
          DisplayNewDirectory;
          HiFn := 1;
          If  SortAsc then begin
            p := FirstFile;
            while (p <> nil) and ((p^.name <> save_name) or (p^.ext <> save_ext)) do begin
{              TempMessageBoxCh(20, 4, yellow, red, 1, p^.name+'.'+p^.ext+int_to_str(p^.fn), ch);}
              p := p^.NextFR;
              inc(HiFn);
            end;
          end
          else begin {SortDesc}
            p := List_End;
            while (p <> nil) and ((p^.name <> save_name) or (p^.ext <> save_ext)) do begin
{              TempMessageBoxCh(20, 4, yellow, red, 1, p^.name+'.'+p^.ext+int_to_str(p^.fn), ch);}
              p := p^.PrevFR;
              inc(HiFn);
            end;
          end;
          TopFn := save_TopFn;
          BotFn := pred( TopFn + ColumnsWide*R);
          If BotFn > TotalFiles then BotFn := TotalFiles;
          if HiFn > BotFn then begin
            inc(TopFn);
            inc(BotFn);
          end;
          DisplayFiles;
        end;
      end;
    end;
  end;
end;

Procedure DelFile;
var
  f : file;
  ch : char;
  full_file_name : string;
  p : FRptr;
begin
  p := Filepointer(HiFn);
{  If ( 1=1 ) then begin  } {not Subdirectory(p^.Attr) then begin}
    full_file_name := PathNoslash(Pathchild(File_Name(HiFn)));
    If(DTTT.AskBeforeDEL) then Begin
      TempMessageBoxCh(25, 2, yellow, red, 1,
          'Delete '+full_file_name+' ? (Y/N)', ch);
    end;
      If ((Not DTTT.AskBeforeDEL)  OR (upcase(ch) = 'Y') ) then begin
        assign(f,full_file_name);
      {$i-}
    {  end }
      if ( not Subdirectory(p^.Attr))then begin
         erase(f);
      end
      else begin
         rmdir(full_file_name);
      end;
      {$i+}
      if ioresult = 0 then begin
        if FirstFile^.Fn = p^.Fn then begin
          FirstFile := p^.NextFR;           {update first pointer}
        end
        else begin
          p^.PrevFR^.NextFR := p^.NextFR;    {update previous recs next pointer}
        end;
        if List_end^.Fn = p^.Fn then begin
          List_End := p^.PrevFR;             {update end pointer}
        end
        else begin
          p^.NextFR^.PrevFR := p^.PrevFR;    {update next recs previous pointer}
        end;
        if HiFn = TotalFiles then dec(HiFn);
        dec(TotalFiles);
        dec(TotalBytes,p^.Size);
        RecalcBotFn;
        Display_Box;
        FillInfo;
        DisplayFiles;
      end
      else begin {could not delete}    { Scott Fix here for DEL Readonly }
        TempMessageBoxCh(25, 2, yellow, red, 1,
        'Could not delete '+full_file_name, ch);
      end;
    end;
{  end;  }
end;

    Procedure Process_Keys;
    var
      ChD : char;
      Finished : Boolean;
      CurrentDir : string;
    begin
        Finished := false;
        If TotalFiles = 0 then
        begin
{$IFDEF DIRFULL}
            Repeat
                 Case No_Files_Found of
                 0 : exit;  {user selected a file}
                 99: begin  {user escaped}
                         Retcode := NoFilesCode;
                         Exit;
                     end;
                 end; {case}
            until TotalFiles <> 0;
{$ELSE}
           Retcode := NoFilesCode;
           Exit;
{$ENDIF}
        end;
        Repeat
             ChD := upcase(GetKey);
{             writeln(Ord(Chd));                }
             Case ChD of

             DToggleAskDelKey : DTTT.AskBeforeDEL := Not DTTT.AskBeforeDEL;
             DMoveKey : MoveFile;
             DCopyKey : CopyFile;
             DRenameKey : RenameFile;
             DViewKey : ViewFile(PathNoslash(Pathchild(File_Name(HiFn))));
             DDelKey  : DelFile;

             #129,                  {mouse down, down arrow}
             #208 :  If not BottomLine then
                     begin
                         LoLightFile(HiFn);
                         Hifn := HiFn + Columnswide;
                         If HiFn <= BotFn then
                            HiLightFile(HiFn)
                         else
                            Scroll_Down;
                     end;
             #128,                      {mouse up, up arrow}
             #200 : If not TopLine then
                    begin
                        LoLightFile(HiFn);
                        Hifn := HiFn - Columnswide;
                        If HiFn >= TopFn then
                           HiLightFile(HiFn)
                        else
                           Scroll_Up;
                    end;
             #205 : If HiFn < TotalFiles then  {right arrow}
                    begin
                        LolightFile(HiFn);
                        Inc(HiFn);
                        If HiFn > BotFn then
                           Scroll_Down
                        else
                           HiLightFile(HiFn);
                    end;
             #131 : If  (LastColumn = false) and (HiFn < BotFn) then  {mouse right}
                    begin
                        LolightFile(HiFn);
                        Inc(HiFn);
                        HiLightFile(HiFn);
                    end;
             #130 : If (FirstColumn = false) then   {mouse left}
                    begin
                       LolightFile(HiFn);
                       Dec(HiFn);
                       HiLightFile(HiFn);
                    end;
             #203 : If HiFn > 1 then {Left arrow}
                    begin
                        LolightFile(HiFn);
                        Dec(HiFn);
                        If HiFn < TopFn then
                           Scroll_Up
                        else
                           HiLightFile(HiFn);
                    end;
             #199 : If Columnswide = 1 then
                    begin
                        If TopFn = 1 then
                        begin
                            LoLightFile(HiFn);
                            HiFn := 1;
                             HiLightFile(HiFn);
                        end
                        else
                           Scroll_Top;
                    end
                    else  {multiple column}
                    begin
                        If not FirstColumn then   {home}
                        begin
                            LoLightFile(HiFn);
                            HiFn := HiFn - (pred(HiFn) mod ColumnsWide);
                            HiLightFile(HiFn);
                        end;
                    end;
             #207 : If ColumnsWide = 1  then   {end}
                    begin
                        If TotalFiles <= BotFn then
                        begin
                             LoLightFile(HiFn);
                             HiFn := TotalFiles;
                             HiLightFile(HiFn);
                        end
                        else
                           Scroll_Bottom;
                    end
                    else
                    begin
                        If not LastColumn then
                        begin
                            LoLightFile(HiFn);
                            HiFn := HiFn
                                  + Columnswide
                                  - HiFn mod ColumnsWide;
                            If HiFn > BotFn then
                               HiFn := BotFn;
                            HiLightFile(HiFn);
                        end;
                    end;
             #245 : If HiFn < TotalFiles then      {Ctrl End}
                    begin
                        If BotFn = TotalFiles then
                        begin
                             LoLightFile(HiFn);
                             HiFn := TotalFiles;
                             HiLightFile(HiFn);
                        end
                        else
                        begin
                           BotFn := TotalFiles;
                           RecalcTopFn;
                           HiFn := TotalFiles;
                           DisplayFiles;
                        end;
                    end;
             #201 : If HiFn > 1 then               {PgUp}
                    begin
                        If TopFn > 1 then
                        begin
                            TopFn := TopFn - R*ColumnsWide;
                            If TopFn < 1 then
                               TopFn := 1;
                        end;
                        RecalcBotFn;
                        HiFN := HiFn - R*ColumnsWide;
                        If HiFn < 1 then
                           HiFn := 1;
                        DisplayFiles;
                    end;
             #209 : If Hifn < TotalFiles then      {PgDn}
                    begin
                        If BotFn < TotalFiles then
                        begin
                            TopFn := TopFN + R*ColumnsWide;
                            BotFn := BotFn + R*ColumnsWide;
                            HiFn := HiFn + R*ColumnsWide;
                            If BotFn > TotalFiles then
                            begin
                                BotFn := TotalFiles;
                                RecalcTopFn;
                                If  (HiFn < TopFn) then
                                    Repeat
                                        HiFn := HiFn + ColumnsWide;
                                    Until HiFN >= TopFN
                                else
                                    If (HiFn > BotFn)  then
                                        HiFn := BotFn;
                            end;
                            DisplayFiles;
                        end
                        else     {Botfn is last file}
                        begin
                            LoLightFile(HiFn);
                            If BottomLine then
                                HiFn := BotFn
                            else
                                HiFn := HiFn + R*ColumnsWide;
                            If HiFn > BotFn then
                               HiFn := BotFn;
                            HiLightFile(HiFn);
                        end;
                    end;
             #247 : If HiFn > 1 then      {Ctrl Home}
                    begin
                        If TopFn = 1 then
                        begin
                             LoLightFile(HiFn);
                             HiFn := 1;
                             HiLightFile(HiFn);
                        end
                        else
                           Scroll_Top;
                    end;
       DTogglekey : If DTTT.AllowToggle then
                    begin
                        ShowingDetails := not ShowingDetails;
                        If Not ShowingDetails then  begin
                           ColumnsWide := DTTT.ColsWide;
{                           GetMem(Sc,160*DisplayLines);
                           MoveFromScreen(BaseOfScreen^,Sc^,160*DisplayLines Div 2);   }
                        end
                        else begin
                           Columnswide := 1;
{                           MoveToScreen(Sc^,BaseOfScreen^,160*DisplayLines);
                           freemem(Sc,160*displaylines);                             }
                        end;
                        MoveToScreen(Scrn^,BaseOfScreen^,160*DisplayLines);
                        Calculate_Box_Dimensions;
                        If Zoomed then
                        begin
                            Y3 := DTTT.Zoomline;
                            R := pred(Y3 - Y2);
                        end;
                        TopFn := 0;
                        Repeat
                            If TopFN = 0 then
                               TopFn := 1
                            else
                               TopFn := TopFN + R*ColumnsWide;
                            BotFn := pred( TopFn + ColumnsWide*R);
                            If BotFn > TotalFiles then
                            begin
                               BotFn := TotalFiles;
                               If BotFn - pred(R*ColumnsWide) > 0 then
                                  TopFn := BotFN - pred(R*ColumnsWide);
                            end;
                        until ((HiFn >= TopFn) and (HiFn <= BotFn));
                        Display_Box;
                        FillInfo;
                        DisplayFiles;
                    end;
{$IFDEF DIRFULL}
         DZoomKey : If DTTT.AllowZoom then
                    begin
                        If Zoomed then
                        begin
                           MoveToScreen(Scrn^,BaseOfScreen^,80*DisplayLines);
                            Zoomed := false;
                            Y3 := Y3_Unzoomed;
                            R := pred(Y3 - Y2);
                            RecalcBotFn;
                            If HiFn > BotFn then
                               HiFn := BotFn;
                            Display_Box;
                            FillInfo;
                            DisplayFiles;
                        end
                        else
                        begin
                            If (DTTT.ZoomLine > Y3) and (DTTT.ZoomLine <= DisplayLines) then
                            begin
                                MoveToScreen(Scrn^,BaseOfScreen^,80*DisplayLines);
                                Zoomed := true;
                                Y3 := DTTT.ZoomLine;
                                R := pred(Y3 - Y2);
                                RecalcBotFn;
                                Display_Box;
                                FillInfo;
                                DisplayFiles;
                            end;
                        end;
                    end;
    DSortOrderKey : If DTTT.AllowSort then
                    begin
                        SortAsc := not SortAsc;
                        TopFn := 1;
                        HiFn := 1;
                        RecalcBotFn;
                        DisplayFiles;
                    end;
    DSortNameKey  : If DTTT.AllowSort and (SortOrder <> DSortName) then
                    begin
                        SortOrder := DSortName;
                        ReSort;
                    end;
    DSortExtKey   : If DTTT.AllowSort and (SortOrder <> DSortExt) then
                    begin
                        SortOrder := DSortExt;
                        ReSort;
                    end;
    DSortSizeKey  : If DTTT.AllowSort and (SortOrder <> DSortSize) then
                    begin
                        SortOrder := DSortSize;
                        ReSort;
                    end;
    DSortTimeKey  : If DTTT.AllowSort and (SortOrder <> DSortTime) then
                    begin
                        SortOrder := DSortTime;
                        ReSort;
                    end;
    DSortDOSKey   : If DTTT.AllowSort and (SortOrder <> DSortDOS) then
                    begin
                        SortOrder := DSortDOS;
                        ReSort;
                    end;
    DHelpKey      : If DTTT.AllowHelp then
                       ShowHelpScreen;
    DJumpParentKey: If DTTT.AllowCD and (length(PathName) > 3) then  {Enter}
                    begin
                        remember(PathName, File_Name(HiFn));
                        PathName := PathParent(PathName);
                        Release(DirTop);
                        DisplayNewDirectory;
                    end;
    DChangeDirKey : If DTTT.AllowCD then begin
                      remember(PathName, File_Name(HiFn));
                      PromptForDirectory;
                    end;
    #33..#126     : If DTTT.AllowInput then begin {user entered an alpha numeric}
                      ChosenFile := PromptForFilename(ChD);
                      If ChosenFile <> '' then begin
                        if ChosenFile = '*' then ChosenFile := '*.*';
                        if (ChosenFile[Length(ChosenFile)] = ':') or
                           (ChosenFile[Length(ChosenFile)] = '\') then begin
                          ChosenFile := ChosenFile +'*.*';
                        end;
                        if (pos('\',ChosenFile) = 0) and
                           (pos(':',ChosenFile) = 0) then begin
                          ChosenFile := PathName + ChosenFile;
                        end;
                        if ((pos(':',chosenFile) = 0) and
                            (Pathname <> '' ))then begin
                          ChosenFile := Copy(Pathname,1,2) + ChosenFile;
                        end;
                        GetDir(0,CurrentDir); { 0 = Current drive }
                        {$I-}
                        ChDir(ChosenFile);
                        if IOResult = 0 then
                           ChosenFile:=ChosenFile + '\*.*';
                        {$I+}
                        ChDir(CurrentDir);
                        DIRFULLFileName := ChosenFile;
                        Extract_Path_Mask;
                        Release(DirTop);
                        DisplayNewDirectory;
                      end;
                    end;
{$ENDIF}
             #133,                                                 {Mouse left}
             #13  : If SubDirectory(FilePointer(HiFn)^.Attr) then begin {Enter}
                      remember(PathName, File_Name(HiFn));
                      If File_Name(HiFn) = '..' then begin
                        PathName := PathParent(PathName)
                      end
                      else begin
                        PathName := PathChild(File_Name(HiFn));
                      end;
                      Release(DirTop);
                      DisplayNewDirectory;
                    end
                    else
                    begin
                        Finished := true;
                        ChosenFile := PathName+File_Name(HiFn);
      {$I-}
                        Chdir(PathNoSlash(PathParent(ChosenFile)));
                        if IOresult <> 0 then
                              writeln('Error: Cannot change to ',PathNoSlash(PathParent(ChosenFile)));
      {$I+}
                    end;
             #132,                          {mouse right}
             #027 : begin                   {esc}
                        Finished := true;
                        Retcode := EscCode;
                        ChosenFile := '';
                    end;
             end;  {case}
             If TotalFiles = 0 then
             begin
       {$IFDEF DIRFULL}
                   Repeat
                      Case No_Files_Found of
                      0 : exit;  {user selected a file}
                      99: begin  {user escaped}
                               Retcode := NoFilesCode;
                               Exit;
                            end;
                      end; {case}
                   until TotalFiles <> 0;
       {$ELSE}
                Retcode := NoFilesCode;
                Exit;
       {$ENDIF}
             end;
        Until Finished;
    end; {sub proc Process_Keys}

    Procedure SaveInitScreen;
    var S : word;
    begin
        S := 160*DisplayLines;
        If MaxAvail < S then
           NoMemory := true
        else
        begin
            Getmem(Scrn,160*DisplayLines);
            MoveFromScreen(BaseOfScreen^,Scrn^,S div 2);
            FindCursor(CursRec[1],Cursrec[2],Cursrec[3],Cursrec[4]);
            OffCursor;
        end;
    end;

    Procedure Clear;
    begin
        If DTTT.RestoreScreen then
            MoveToScreen(Scrn^,BaseOfScreen^,80*DisplayLines);
        PosCursor(Cursrec[1],Cursrec[2]);
        SizeCursor(Cursrec[3],Cursrec[4]);
        Release(HeapTop);
        If not DTTT.RestoreScreen then begin
          gotoxy(1,25);
        end;
    end;

begin          {main procedure}
    Mark(HeapTop);
    NoMemory := False;
    Zoomed := False;
    ShowingDetails := DTTT.ShowDetails;
    SortAsc := DTTT.Asc = 0;
    SortOrder := DTTT.InitSort;
    If Not ShowingDetails then
       ColumnsWide := DTTT.ColsWide
    else
       Columnswide := 1;
{    SaveInitScreen;
    If NoMemory then
    begin
        Retcode := Memcode;
        exit;
    end;                                 }
    {$I-}
    GetDir(0,StartDir);
    {SI+}
    If IOResult <> 0 then
    begin
        Retcode := UnknownCode;
        exit;
    end;
    Retcode := OKCode;     {assume it will succeed!}
    Extract_Path_Mask;
    Calculate_Box_Dimensions;
    Y3_unzoomed := Y3;   {ugh?}
    DisplayNewDirectory;
    ShowHelpScreen;
    SaveInitScreen;
    If NoMemory then
    begin
        Retcode := Memcode;
        exit;
    end;
    If NoMemory then
    begin
       Retcode := Memcode;
    end
    else
       Process_Keys;
    gotoxy(1,25);
    Writeln('');
    SizeCursor(Cursrec[3],Cursrec[4]);
end;

var
  Chosen_File : string;
  ErrCode : integer;
  CurrentDir : string;
  Paramone : string;

begin {main}
  Default_Settings;
  Horiz_Sensitivity := 3;
  DTTT.Rows := 19;
  DTTT.Asc := Descending;
  DTTT.InitSort := DsortTime;
  DTTT.RestoreSCreen := false;
  Paramone := Paramstr(1);
  if paramone = '' then paramone := '*.*'
  else if paramone = '*' then paramone := '*.*'
  else begin
    if((paramone[Length(Paramone)] = ':')  or
       (paramone[Length(Paramone)] = '\')) then begin
      Paramone := Paramone + '*.*'
    end
    else begin
      GetDir(0,CurrentDir); { 0 = Current drive }
      {$I-}
      ChDir(Paramone);
      if IOResult = 0 then Paramone:=Paramone + '\*.*';
      {$I+}
      ChDir(CurrentDir);
    end;
  end;
  if pos(':',paramone) = 0 then begin
    GetDir(0,CurrentDir); { 0 = Current drive }
    paramone := copy(CurrentDir,1,2) + paramone;
  end;
  Chosen_File := Display_Directory(paramone,Errcode);
end.
