PROGRAM Dir_Size(input, output);

USES
  Dos;

VAR
  i     : integer;
  Total : longint;
  Root  : string;
  Regs  : registers;
  default_drive       : byte;
  new_default_drive   : byte;
  sectors_per_cluster : byte;
  bytes_per_sector    : word;
  bytes_per_cluster   : word;


FUNCTION cluster_size_of(s : longint):longint;

BEGIN
  cluster_size_of := (s + bytes_per_cluster - 1) div bytes_per_cluster *
      bytes_per_cluster;
END;


FUNCTION SizeOfDir(NameOfDir : string) : longint;

VAR
  DirInfo  : SearchRec;
  DirSize,
  TotSize : longint;

BEGIN
  DirSize := 0;
  TotSize  := 0;
  FindFirst(NameOfDir+'*.*', Directory, DirInfo);
  WHILE (DosError = 0) DO BEGIN
    IF ((DirInfo.Attr and Directory) > 0) THEN BEGIN
      TotSize := TotSize + cluster_size_of(DirInfo.Size);
      IF ((DirInfo.Name <> '.') AND (DirInfo.Name <> '..')) THEN
          TotSize := TotSize + SizeOfDir(NameOfDir+DirInfo.Name+'\');
    END
    ELSE TotSize := TotSize + cluster_size_of(DirInfo.Size);
    DirSize := DirSize + cluster_size_of(DirInfo.Size);
    FindNext(DirInfo);
  END;
  SizeOfDir := TotSize;
  IF (NameOfDir = Root) THEN
    writeln(DirSize:9, '  ', Root, ' (Root Directory)')
  ELSE
    writeln(DirSize:9, '  ', NameOfDir);
END;

BEGIN {main}

  Root := fexpand(ParamStr(1)+'\');

  Regs.ah := $19;           {function code to get default drive}
  MsDos(regs);              {call DOS }
  default_drive := regs.al; {save default drive}

  Regs.ah := $0e;           {function code to change default drive}
  new_default_drive := ord(upcase(Root[1]))-ord('A') + 1;
  regs.dl := new_default_drive;
  MsDos(regs);              { Call DOS }

  Regs.ah := $1C;           {function code to get disk info}
  MsDos(regs);              { Call DOS }
  sectors_per_cluster := Regs.al;
  bytes_per_sector := Regs.cx;
  bytes_per_cluster := sectors_per_cluster * bytes_per_sector;

  Regs.ah := $0e;           {function code to change default drive}
  regs.dl := default_drive;
  MsDos(regs);              { Call DOS }

  writeln;
  writeln(' The cluster size of ',copy(root,1,2), ' is ',bytes_per_cluster,
          ' bytes.');
  writeln;

  FOR i := 1 TO Length(Root) DO Root[i] := UpCase(Root[i]);
  writeln('     Size  Directory');
  writeln('     ----  ---------');
  Total := SizeOfDir(Root);
  writeln;
  writeln(Total:9, '  Total Size of the ', Root, ' tree.');

END.
