program fdir;
uses dos, opdos, opcrt, OpEMS, OpExtMem;
var
  DirInfo: SearchRec;
  drive_let : char;
  subst_let : char;
  disk_class : diskclass;
  s : string;
  found_one : boolean;

function disk_type(disk_class:DiskClass):string;
begin
  case disk_class of
    Floppy360:    disk_type := '360K Floppy';
    Floppy720:    disk_type := '720K Floppy';
    Floppy12:     disk_type := '1.2M Floppy';
    Floppy144:    disk_type := '1.4M Floppy';
    OtherFloppy:  disk_type := 'Other Floppy';
    Bernoulli:    disk_type := 'Bernoulli';
    HardDisk:     disk_type := 'Hard Disk';
    RamDisk:      disk_type := 'RAM Disk';
    SubstDrive:   disk_type := 'SUBST Drive';
    UnknownDisk:  disk_type := 'Unknown Disk';
    InvalidDrive: disk_type := 'Invalid Drive';
  end;
end;


PROCEDURE Look_for_dirs_in(NameOfDir : string);

VAR
  DirInfo  : SearchRec;

BEGIN

  {look for subdirs to search}
  FindFirst(NameOfDir+'*.*', Directory, DirInfo);
  WHILE (DosError = 0) DO BEGIN
    IF (DirInfo.Attr = Directory) THEN BEGIN
      IF ((DirInfo.Name <> '.') AND (DirInfo.Name <> '..')) THEN BEGIN
          Look_for_dirs_in(NameOfDir+DirInfo.Name+'\');
      END;
    END;
    FindNext(DirInfo);
  END;

  {look in this dir for specified dir(s)}
  FindFirst(NameOfDir+s, Directory, DirInfo);
  WHILE (DosError = 0) DO BEGIN
    IF (DirInfo.Attr = Directory) THEN BEGIN
      IF ((DirInfo.Name <> '.') AND (DirInfo.Name <> '..')) THEN BEGIN
        found_one := true;
        Writeln('  ', NameOfDir, DirInfo.Name);
      END;
    END;
    FindNext(DirInfo);
  END;
END;


begin {main}
  found_one := false;
  writeln;
  s := paramstr(1);
  if s = '' then begin
    writeln('   FDIR finds directories. It identifies all the directories');
    writeln('   on each of your hard drives that meet the wild_spec.');
    writeln;
    writeln('   Syntax: FDIR wild_spec');
    halt;
  end;
  drive_let := 'C';
  disk_class := GetDiskClass(drive_let, subst_let);
  while disk_class = HardDisk do begin
    Writeln('Searching ', drive_let, ':');
    Look_for_dirs_in(drive_let+':\');
    inc(byte(drive_let));
    disk_class := GetDiskClass(drive_let, subst_let);
  end;
  if not found_one then writeln('No directories meet the wild_spec.');
end.
