program info;
uses dos, opdos, opcrt, OpEMS, OpExtMem;
var
  drive : byte;
  drive_let : char;
  subst_let : char;
  disk_class : diskclass;
  size  : longint;
  used  : longint;
  avail : longint;
  pages : longint;
  memory : longint;
  tot_size  : longint;
  tot_used  : longint;
  tot_avail : longint;
  s : string;

function amt(x:longint):string;
{returns a string len chars long of x w/ commas, e.g. ' 2,345,761'}
const
  len = 10;
var
  s:string[13];
  p:integer;
begin
  str(x:len, s);
  p := len - 3;
  while p > 0 do begin
    if s[p] = ' ' then insert(' ', s, p+1)
    else insert(',', s, p+1);
    dec(p,3);
  end;
  amt := s;
end;

function disk_type(disk_class:DiskClass):string;
begin
  case disk_class of
    Floppy360:    disk_type := '360K Floppy';
    Floppy720:    disk_type := '720K Floppy';
    Floppy12:     disk_type := '1.2M Floppy';
    Floppy144:    disk_type := '1.4M Floppy';
    OtherFloppy:  disk_type := 'Other Floppy';
    Bernoulli:    disk_type := 'Bernoulli';
    HardDisk:     disk_type := 'Hard Disk';
    RamDisk:      disk_type := 'RAM Disk';
    SubstDrive:   disk_type := 'SUBST Drive';
    UnknownDisk:  disk_type := 'Unknown Disk';
    InvalidDrive: disk_type := 'Invalid Drive';
  end;
end;


begin {main}
  textcolor(white);
  textbackground(blue);
  clrscr;
  writeln;
  writeln('Current configuration information for this machine is:');
  writeln;
  writeln('  DOS version = ', hi(DosVersion), '.', lo(DosVersion));

(*  CRASHES WITH DOS 5.0
  writeln('  EMS (Expanded memory) total =',   amt(EMSTotalPages*longint(16384)));
  writeln('  XMS (Extended memory) total =',   amt(ExtMemTotal));
*)

  tot_size  := 0;
  tot_used  := 0;
  tot_avail := 0;
  s := paramstr(1)+' ';
  if upcase(s[1]) in ['A'..'Z'] then drive_let := upcase(s[1])
                                else drive_let := 'C';
  if drive_let <> 'A' then begin
    writeln;
    writeln('  Starting with drive ', drive_let, ':');
  end;
  disk_class := GetDiskClass(drive_let, subst_let);
  if (drive_let in ['A', 'B']) and (disk_class = InvalidDrive) then begin
    writeln;
    writeln('  Please place a disk in drive ', drive_let, ': and rerun INFO.');
    writeln;
    halt;
  end;
  writeln;
  writeln('  Drive      Size         Used      Available   Type');
  while disk_class <> InvalidDrive do begin
    drive := ord(drive_let)-ord('A')+1;
    size  := disksize(drive);
    avail := diskfree(drive);
    used  := size - avail;
    writeln('    ', drive_let, ':',
            amt(size), amt(used),  amt(avail), '  ', disk_type(disk_class));
    inc(tot_size,size);
    inc(tot_used,used);
    inc(tot_avail,avail);
    inc(byte(drive_let));
    disk_class := GetDiskClass(drive_let, subst_let);
    if (drive_let = 'B') and (disk_class = InvalidDrive) then begin
      writeln;
      writeln('  Please place a disk in drive ', drive_let, ': and rerun INFO.');
      writeln;
      halt;
    end;
  end;
  if drive_let > 'C' then begin
    writeln('      ', amt(tot_size), amt(tot_used), amt(tot_avail),
            '  Total');
  end
  else writeln('  No hard disk drives found.');
  writeln;
end.
