program isdown;

var
  arg : string;
  i   : byte;

begin
  arg := paramstr(1);

  for  i:= 1 to length(arg) do arg[i] := upcase(arg[i]);

  if arg = 'RIGHT_SHIFT' then if (mem[64:23] and   1) > 0 then halt(1) else halt(0);
  if arg = 'LEFT_SHIFT'  then if (mem[64:23] and   2) > 0 then halt(1) else halt(0);
  if arg = 'CTRL'        then if (mem[64:23] and   4) > 0 then halt(1) else halt(0);
  if arg = 'ALT'         then if (mem[64:23] and   8) > 0 then halt(1) else halt(0);
  if arg = 'SCROLL_LOCK' then if (mem[64:23] and  16) > 0 then halt(1) else halt(0);
  if arg = 'NUM_LOCK'    then if (mem[64:23] and  32) > 0 then halt(1) else halt(0);
  if arg = 'CAPS_LOCK'   then if (mem[64:23] and  64) > 0 then halt(1) else halt(0);
  if arg = 'INS'         then if (mem[64:23] and 128) > 0 then halt(1) else halt(0);

  writeln;
  writeln('  ISDOWN is a utility that returns ERRORLEVEL 1 if a specified key is pressed.');
  writeln;
  writeln('  Syntax:');
  writeln;
  writeln('    ISDOWN key');
  writeln;
  writeln('  where key can be: Alt, Ctrl, Left_shift, Right_shift,');
  writeln('                    Scroll_lock, Num_lock, Caps_lock, or Ins.');
  writeln;
  writeln('  For example, if a batch file had the code segment:');
  writeln;
  writeln('     ISDOWN ALT');
  writeln('     IF ERRORLEVEL 1 GOTO ALT_IS_DOWN');
  writeln;
  writeln('  it would goto to ALT_IS_DOWN, if the alt key was depressed.');
  writeln;
  halt(0);

end.