{$V-,F+}

{*********************************************************}
{*                   LIST.PAS 1.0                        *}
{*********************************************************}

{***************************************************************************
 This program will use features activated with the following defines:
   UseMouse, UseScrollBars
 ***************************************************************************}

{*********************************************************}
{*      Assorted conditional compilation directives      *}
{*********************************************************}

{This compiler directive controls whether the Float type in OPSTRING is
 defined as an Extended or a Real. It also controls the inclusion of certain
 methods that apply only to 8087 numeric types.}

  {$N-}

{This directive forces all units to contain an initialization block, even
 those that do not have any actual initialization code. Adding these blocks
 helps to work around a bug in Turbo Debugger 1.5.}

  {$DEFINE InitAllUnits}

{This directive determines whether or not OPCRT is compiled in such a way as
 to coexist peacefully with the standard Turbo Pascal CRT unit.}

  {.$DEFINE UseCrt}

{This directive enables mouse support in several of the units, as well as in
 some of the demo programs}

  {$DEFINE UseMouse}

{This directive enables scroll bar support in OPWINDOW and units that
 depend on it}

  {$DEFINE UseScrollBars}

{This directive enables hot spot support in OPWINDOW and units that depend
 on it}

  {$DEFINE UseHotSpots}

{This directive enables shadowing support in OPWINDOW}

  {$DEFINE UseShadows}

{This directive enables the AdjustWindow, ResizeWindow, MoveWindow, and other
 methods in OPWINDOW}

  {$DEFINE UseAdjustableWindows}

{If FourByteDates is defined, dates in OPDATE are stored as longints, giving a
range of 01/01/1600-12/31/3999. If it isn't defined, dates are stored as words,
giving a range of 01/01/1900-12/31/2078.}

  {$DEFINE FourByteDates}

{The following directive enables support for editing of dates in OPEDIT and
OPENTRY. It also enables certain options in OPDIR, OPEDIT, OPENTRY, and
OPFORM.}

  {$DEFINE UseDates}

{The following directive enables support for BCD reals in OPEDIT, OPENTRY and
OPFORM}

  {.$DEFINE UseBCD}

{The following directive enables support for pick list fields in OPENTRY}

  {$DEFINE PickListFields}

{Deactivate the following define if the caller of OPSORT needs to perform
 heap allocation or deallocation while the sort is in progress, that is,
 within the user-defined procedures of the sort. For large sorts with
 element size exceeding 4 bytes, FastDispose makes a significant difference
 in the speed of heap deallocation when the sort is finished.}

  {$DEFINE FastDispose}

{If the following directive is defined, OPTSR and OPSWAP try to
 thwart SideKick}

  {$DEFINE ThwartSideKick}

{If the following directive is defined, streams support is enabled in all
 objects}

  {$DEFINE UseStreams}

{If the following directive is defined, XMS support is enabled in OPSWAP and
 OPEXEC. IMPORTANT: in that case you must also define the SupportXms constant
 in OPSWAP.ASM and OPEXEC.ASM and reassemble those files. Failure to do so will
 cause an error when recompiling the units.}

  {.$DEFINE SupportXms}                        {!!.02}

{If the following directive is defined, OPDRAG support will be included in all
 units containing command windows.}

  {.$DEFINE UseDrag}

{The following define controls how various OPRO units react to the heap
 changes of TP6. There's no need for you to modify it.}

  {$IFDEF Ver60}
  {$DEFINE Heap6}
  {$ENDIF}


{----------------------------------------------------------------------------}
program List;
  {-File browser}

uses
  Dos,
  OpCmd,
  OpCrt,
  OpString,
  OpRoot,
  OpDos,
  {$IFDEF UseMouse}
  OpMouse,
  {$ENDIF}
  OpEdit,
  OpFrame,
  OpWindow,
  OpList;

const
  OurColorSet : ColorSet = (
    TextColor       : $1E; TextMono       : $07;
    CtrlColor       : $1E; CtrlMono       : $07;
    FrameColor      : $1B; FrameMono      : $0F;
    HeaderColor     : $0F; HeaderMono     : $0F;
    ShadowColor     : $07; ShadowMono     : $07;
    HighlightColor  : $4F; HighlightMono  : $70;
    PromptColor     : $3F; PromptMono     : $07;
    SelPromptColor  : $3F; SelPromptMono  : $07;
    ProPromptColor  : $07; ProPromptMono  : $07;
    FieldColor      : $31; FieldMono      : $07;
    SelFieldColor   : $31; SelFieldMono   : $07;
    ProFieldColor   : $07; ProFieldMono   : $07;
    ScrollBarColor  : $07; ScrollBarMono  : $07;
    SliderColor     : $07; SliderMono     : $07;
    HotSpotColor    : $70; HotSpotMono    : $07;
    BlockColor      : $2F; BlockMono      : $0F;
    MarkerColor     : $0F; MarkerMono     : $70;
    DelimColor      : $0F; DelimMono      : $0F;
    SelDelimColor   : $70; SelDelimMono   : $70;
    ProDelimColor   : $07; ProDelimMono   : $07;
    SelItemColor    : $2F; SelItemMono    : $70;
    ProItemColor    : $17; ProItemMono    : $07;
    HighItemColor   : $1F; HighItemMono   : $0F;
    AltItemColor    : $1F; AltItemMono    : $0F;
    AltSelItemColor : $2F; AltSelItemMono : $70;
    FlexAHelpColor  : $1F; FlexAHelpMono  : $0F;
    FlexBHelpColor  : $1F; FlexBHelpMono  : $0F;
    FlexCHelpColor  : $1B; FlexCHelpMono  : $70;
    UnselXrefColor  : $1E; UnselXrefMono  : $09;
    SelXrefColor    : $5F; SelXrefMono    : $70;
    MouseColor      : $4A; MouseMono      : $70
  );
var
  HelpWindow     : RawWindow;
  HelpLineWindow : RawWindow;
  Charpressed : Char;
  FName : string[64];
  BR : Browser;
  SearchRecord : SearchRec;
  Path : string[64];
  NextParam, Wid : Byte;
  First_time : Boolean;
  None_found : Boolean;

  procedure ClearStatusLine;
    {-Clear the status line}
  {$IFDEF UseMouse}
  var
    SaveMouse : Boolean;
  {$ENDIF}
  begin
    {$IFDEF UseMouse}
    HideMousePrim(SaveMouse);
    {$ENDIF}

    with OurColorSet do
      FastWrite(CharStr(' ', 80), 1, 1, ColorMono(PromptColor, PromptMono));

    {$IFDEF UseMouse}
    ShowMousePrim(SaveMouse);
    {$ENDIF}
  end;

  procedure ErrorProc(UnitCode : Byte; var ErrCode : Word; Msg : string);
    {-Error handler}
  var
    I : Word;
    CursorSL, CursorXY : Word;
    {$IFDEF UseMouse}
    SaveMouse : Boolean;
    {$ENDIF}
  begin
    {save the cursor position and shape}
    GetCursorState(CursorXY, CursorSL);

    {$IFDEF UseMouse}
    HideMousePrim(SaveMouse);
    {$ENDIF}

    {clear the status line}
    ClearStatusLine;

    {display the error message}
    Msg := ' '+Msg+'. Press any key...';
    with OurColorSet do
      FastWrite(Msg, 1, 1, ColorMono(PromptColor, PromptMono));

    {$IFDEF UseMouse}
    ShowMousePrim(SaveMouse);
    {$ENDIF}

    {position the cursor at the end of the message}
    NormalCursor;
    GotoXYabs(Length(Msg)+1, 1);

    {wait for a keypress}
    I := ReadKeyWord;

    {Restore cursor position and shape}
    RestoreCursorState(CursorXY, CursorSL);
  end;

  function EditProc(MsgCode : Word;
                    Prompt : string;
                    ForceUp : Boolean;
                    TrimBlanks : Boolean;
                    MaxLen : Byte;
                    var S : string) : Boolean;
   {-Line editing routine}
  var
    LE : LineEditor;
    Width : Byte;
  begin
    with LE do begin
      ClearStatusLine;
      Init(OurColorSet);
      if ForceUp then
        leEditOptionsOn(leForceUpper)
      else
        leEditOptionsOff(leForceUpper);
      if TrimBlanks then
        leEditOptionsOn(leTrimBlanks)
      else
        leEditOptionsOff(leTrimBlanks);
      Prompt := ' '+Prompt;
      if Length(Prompt)+MaxLen > 80 then
        Width := 79-Length(Prompt)
      else
        Width := MaxLen;
      ReadString(Prompt, 1, 1, MaxLen, Width, S);
      EditProc := (GetLastCommand <> ccQuit);
    end;
  end;

  function YesNo(Prompt : string; Default : Char) : Boolean;
    {-Get a response to a yes-no question}
  var
    LE : LineEditor;
  begin
    with LE do begin
      ClearStatusLine;
      Init(OurColorSet);
      leEditOptionsOn(leAllowEscape);
      YesNo := YesOrNo(Prompt, 1, 1, Default);
    end;
  end;

  function GetFile(MsgCode : Word; Prompt : string;
                   ForceUp, TrimBlanks, Writing, MustExist : Boolean;
                   MaxLen : Byte;  DefExt : ExtStr;
                   var S : string) : Boolean;
    {-Get a filename}
  var
    I : Word;
  begin
    if not EditProc(MsgCode, Prompt, ForceUp, TrimBlanks, MaxLen, S) then
      GetFile := False
    else if Writing then
      if ExistFile(S) then
        GetFile := YesNo('File exists. Overwrite it?', 'N')
      else
        GetFile := True
    else if ExistFile(S) or not MustExist then
      GetFile := True
    else begin
      I := ecFileNotFound;
      ErrorProc(ucNone, I, emFileNotFound);
      GetFile := False;
    end;
  end;

  procedure Help;
    {-Display help message}
  begin
     WriteLn('LIST is a file browser. The command line syntax is:');
     WriteLn;
     WriteLn('  LIST filename.ext [filename.ext]');
     WriteLn('  Multiple filenames may be specified after the program name, and');
     WriteLn('  filenames may contain wildcard characters ("*", "?") if desired.');
     WriteLn('  When you get into LIST, press F1 for more help.');
     Halt(0);
  end;

  function BrowseFile : Boolean;
    {-Browse the next file in SearchRecord}
  begin
    with BR do begin
      {try to open the file}
      OpenFile(Path+SearchRecord.Name);

      {check the error code}
      DosError := GetLastError;

      if DosError = 0 then begin
        {browse through the file}
        Process;

        {evaluate the exit command}
        case GetLastCommand of
          ccUser0 :     {user wants to quit}
            DosError := ecFileNotFound;
          ccError :     {an error occurred}
            DosError := GetLastError;
        end;

        {close the file}
        CloseFile;
        if DosError = 0 then
          DosError := GetLastError;
      end;
    end;

    BrowseFile := (DosError = 0);
  end;

procedure ListHelpProc(UNitCode : Byte; IdPtr : Pointer; HelpIndex : Word);
begin
{  IF GraphDriver <> 1 THEN
    HelpWindow.InitCustom(2, 2, 77, 40, EsColors, wBordered+wClear)
  ELSE}
    if not HelpWindow.InitCustom(2, 2, 78, 24, OurColorSet, wBordered+wClear)
        then begin
      ClrScr;
      WriteLn(emInsufficientMemory);
      Halt;
    end;
  HelpWindow.wFrame.SetFrameType('ĳ');
  HelpWindow.wFrame.AddHeader('HELP SCREEN FOR LIST',heTC);
  HelpWindow.wFrame.AddHeader('Press any key to exit this help screen',heBC);
  HelpWindow.Draw;

  Writeln('LIST is a file browser.  You are currently browsing ',
      BR.CurrentFileName);
  WriteLn;
  Writeln(' Basic Commands');
  Writeln('   F1 - produces this help screen');
  Writeln('   F5 - search for a string');
  Writeln('   F6 - search for next');
  Writeln('   PgDn - Scroll Window down one page');
  Writeln('   PgUp - Scroll Window up one page');
  Writeln('   Ctrl/PgUp - Top of File');
  Writeln('   Ctrl/PgDn - Bottom of File');
  Writeln('   Arrows - Scroll left, right, up & down');
  Writeln('   Ctrl/right arrow - Scroll right 10 columns');
  Writeln('   Ctrl/left  arrow - Scroll left  10 columns');
  Writeln(' Other commands');
  Writeln('   F3 - Load another file');
  Writeln('   F7 - Mark beginning of block.');
  Writeln('   F8 - Mark end of block');
  Writeln('   F9 - Copy block to a file');
  Writeln('   F10 - Print block (ASCII, not Postscript)');
  Writeln('   Ctrl/H - Toggle to/from HEX mode');
  Writeln('   Ctrl/J L - Jump to a specified line number');
  WriteLn;
  Write  ('   Right mouse click on scroll bar moves to proportional location in file. ');
                                                                                      {^}
  Repeat Until Keypressed ;
  CharPressed := ReadKey ;
  if CharPressed = #0 then CharPressed := ReadKey ;

  HelpWindow.Erase;
  HelpWindow.Done;

end; {ListHelpProc}

begin {main}
  {any parameters?}
  if ParamCount = 0 then Help;

  {do help line}
  if not HelpLineWindow.InitCustom(1, 25, ScreenWidth, ScreenHeight, OurColorSet, wClear)
        then begin
    WriteLn(emInsufficientMemory);
    Halt;
  end;
  HelpLineWindow.Draw;
  StatusColor := OurColorSet.PromptColor;
  StatusMono := OurColorSet.PromptMono;                                                     {v}
  FastWrite('       F1-Help, F5-Find, F6-Find Next, PgDn, PgUp, Arrows, or Esc-Exit          ',
      25, 1, ColorMono(StatusColor, StatusMono));


  {<F5>: find}
  BrowseCommands.AddCommand(ccSearch, 1, $3F00, 0);

  {<F6>: find next}
  BrowseCommands.AddCommand(ccReSearch, 1, $4000, 0);

  {<F9>: block to file}
  BrowseCommands.AddCommand(ccBlkWrite, 1, $4300, 0);

  {<F10>: print block}
  BrowseCommands.AddCommand(ccBlkPrint, 1, $4400, 0);

  {<AltX>: stop browsing}
  BrowseCommands.AddCommand(ccUser0, 1, $2D00, 0);

  {<AltH>: toggle hex mode}
  BrowseCommands.AddCommand(ccHexMode, 1, $2300, 0);

  BrowseCommands.SetHelpProc(ListHelpProc);
  with BR do begin
    {$IFDEF UseScrollBars}
    Wid := ScreenWidth-1;
    {$ELSE}
    Wid := ScreenWidth;
    {$ENDIF}
    {initialize browse window}
    if not InitCustom(1, 2, Wid, ScreenHeight-1,
                      OurColorSet,
                      DefWindowOptions,
                      100000) then begin {!!.01}
                    {  MaxAvail-(480*ScreenHeight)) then begin {!!.01}
                    { MaxAvail-12000) then begin }
      WriteLn(emInsufficientMemory);
      Halt;
    end;

    {make sure that the whole screen gets saved}
    AdjustFrameCoords(1, 1, ScreenWidth, ScreenHeight-1);

    {$IFDEF UseScrollBars}
    {add a custom scroll bar}
    wFrame.AddCustomScrollBar(frRR, 0, MaxLongInt, 1, 0, '', '', OurColorSet);
    {$ENDIF}

    {set procedure pointers}
    SetStatusProc(BrowseStatus);
    SetEditProc(EditProc);
    SetErrorProc(ErrorProc);
    SetGetFileProc(GetFile);

    {$IFDEF UseMouse}
    if MouseInstalled then begin
      {use a red diamond for our mouse cursor}
      with OurColorSet do
        SoftMouseCursor($0000, (ColorMono(MouseColor, MouseMono) shl 8)+$04);

      {enable mouse support in OPBROWSE}
      BrowseCommands.cpOptionsOn(cpEnableMouse);
    end;
    {$ENDIF}

    NextParam := 1;
    First_time := true;
    None_found := false;
    repeat
      {get the path}
      Path := JustPathName(ParamStr(NextParam));
      Path := AddBackSlash(Path);

      {get the first matching file}
      FindFirst(ParamStr(NextParam), $6, SearchRecord);
      if DosError = 0 then begin
        {display the file}
        if not BrowseFile then
          {stop the loop}
          NextParam := ParamCount
        else begin
          {display the rest of the files}
          while DosError = 0 do begin
            {get the next matching file}
            FindNext(SearchRecord);
            if DosError = 0 then begin
              {display the file}
              if not BrowseFile then begin
                {stop the loop}
                NextParam := ParamCount;
              end;
            end;
          end;
        end;
      end
      else begin
        if First_time then None_found := true;
      end;
      {get next parameter}
      Inc(NextParam);
      First_time := false;
    until NextParam > ParamCount;


    if not IsActive then
      {browser was never displayed}
      WriteLn('No matching files found')
    else
      {restore the screen}
      Erase;
  end;

  HelpLineWindow.Erase;
  HelpLineWindow.Done;

  if None_found then writeln('File not found.');

end.


