program push_dir;

procedure help;
begin
  writeln('PUSH_DIR is a command that remembers the current drive and directory. This');
  writeln('allows you to restore yourself to that drive and directory at a later time.');
  writeln('Synax: PUSH_DIR [bat_spec | ?]');
  writeln('  PUSH_DIR                  creates C:\DOS\POP_DIR.BAT');
  writeln('  PUSH_DIR Z:\POP_DIR.BAT   creates Z:\POP_DIR.BAT');
  writeln('  PUSH_DIR ?                displays this help screen');
  writeln;
  writeln('The batch file created has two lines, one to restore the drive and the');
  writeln('other to CD to the original directory. Below is an example batch file');
  writeln('using PUSH_DIR.');
  writeln;
  writeln('DEMO.BAT');
  writeln('  PUSH_DIR');
  writeln('  C:');
  writeln('  CD \MYAPP');
  writeln('  MYAPP');
  writeln('  POP_DIR');
  writeln;
  writeln('Note that the default pop dir name and location is C:\DOS\POP_DIR.BAT.');
  writeln('If you do not have a C:\DOS directory or do not have it on the path, you');
  writeln('may use the second form of PUSH_DIR and specify the name and location of');
  writeln('the batch file that will return you to the current drive and directory.');
end;

var
  fileout   :text;
  curr_loc : string;
  bat_name : string;

begin {main}
  GetDir(0, curr_loc);
  if paramstr(1) = '?' then begin
    help;
    halt;
  end;

  if paramstr(1) = '' then bat_name := 'c:\dos\pop_dir.bat'
                      else bat_name := paramstr(1);

  assign(fileout, bat_name);
  {$I-}
  rewrite(fileout);
  {$I+}

  if ioresult = 0 then begin
    writeln(fileout, copy(curr_loc, 1, 2));
    writeln(fileout,'CD ', copy(curr_loc, 3, 255));
    close(fileout);
  end
  else begin
    writeln;
    writeln('ERROR: cannot create ', bat_name);
    help;
  end;

end.

