program edit;

uses BinEd, Crt;

const
  x1 = 1;
  x2 = 80;
  y1 = 1;
  y2 = 22;
  ExitCommands : array [0..2] of char = (#1, ^Z, #0); {Ctrl-Z an extra exit commands}
type
  scrnarray      = array[0..3999] of byte;
  screenptr      = ^scrnarray;
var
  file_name      : string;
  screenaddress  : word;
  scrnptr        : screenptr;
  dataptr        : pointer;
  EdData         : EdCB;              {Editor control block}
  answer         : char;
  exit_command   : integer;
  x              : byte;
  y              : byte;

begin                         {edit}
  clrscr;
  if paramstr(1) = '' then begin
    write('File name to edit ? ');
    readln(file_name);
  end
  else begin
    file_name := paramstr(1);
  end;

  gotoxy(x1,y1); write(''); for x := x1+1 to x2-1 do write(''); write('');
  for y := y1+1 to y2-1 do begin
    gotoxy(x1,y); write('');
    gotoxy(x2,y); write('');
  end;
  gotoxy(x1,y2); write(''); for x := x1+1 to x2-1 do write(''); write('');
  writeln('Ctrl Z to exit.  You will be be given a chance to save your edits.');

  if (InitBinaryEditor(EdData, 60000{MaxFileSize}, x1+1,y1+1,x2-1,y2-1,
      True, EdOptInsert, '', ExitCommands, nil) <> 0) then
      writeln('Unable to load binary editor.')
  else if (ReadFileBinaryEditor(EdData, file_name) > 1) then
      writeln('Unable to read ' + file_name)
  else begin
    ResetBinaryEditor(EdData);                             {Reset for new file}
    exit_command := UseBinaryEditor(EdData, '');           {Edit the file}
    if ModifiedFileBinaryEditor(EdData) then begin         {Was it modified?}
      repeat
        write('Save File (Y/N) ? ');
        answer := upcase(readkey);
      until answer in ['N', 'Y'];
      writeln;
      if answer = 'Y' then begin
        if (SaveFileBinaryEditor(EdData, True) <> 0) then
            Writeln('Error saving file.');
      end;
    end;
  end;

end.
