program rem_ff;
var
   in_name,out_name : string[80];
   in_file,out_file : file;
   buffer           : array [1..16384] of byte;
   recs             : word;
   ch               : char;
   i                : word;

function exists(var filename_of_any_string_length):boolean;
var
  filename : string[255] absolute filename_of_any_string_length;
  filein : text;
begin
  assign(filein,filename);
  {$I-}
  reset(filein);
  {$I+}
  if ioresult = 0 then begin
    exists:=true;
    close(filein);
    end
  else exists:=false;
  end; {exists}

begin
    if paramstr(2) = '' then begin
      writeln('REM_FF changes all form feed characters to blanks.');
      writeln('Syntax: REM_FF in_file out_file');
      halt;
      end;
    in_name:=paramstr(1);
    out_name:=paramstr(2);
    if in_name = out_name then begin
      writeln;
      writeln('ERROR: You are attempting to copy a file onto itself.',
              '  Program terminating.');
      halt;
      end;
    if not exists(in_name) then begin
      writeln;
      writeln('ERROR: ',in_name,' does not exist.  Program terminating.');
      halt;
      end;
    if exists(out_name) then begin
      writeln;
      write('WARNING: ',out_name,' exists.  Do you want to copy over it? ');
      readln(ch);
      if upcase(ch) <> 'Y' then halt;
      end;
    assign (in_file,in_name);
    reset (in_file,1);
    assign (out_file,out_name);
    rewrite (out_file,1);
    repeat
      blockread (in_file,buffer,16384,recs);
      for i := 1 to recs do if buffer[i] =  12  {a form feed} then
                               buffer[i] := 32; {a blank}
      blockwrite (out_file,buffer,recs);
      until recs=0;
    close (in_file);
    close (out_file);
   end.
