program replace;
var
   in_name,out_name : string[80];
   in_file,out_file : file;
   buffer           : array [1..16384] of byte;
   recs             : integer;
   ch               :char;

function exists(var filename_of_any_string_length):boolean;
var
  filename : string[255] absolute filename_of_any_string_length;
  filein : text;
begin
  assign(filein,filename);
  {$I-}
  reset(filein);
  {$I+}
  if ioresult = 0 then begin
    exists:=true;
    close(filein);
    end
  else exists:=false;
  end; {exists}

begin
  if paramstr(2) = '' then begin
    writeln('Syntax: REPLACE file1 file2');
    writeln('        Replaces file2''s contents with the contents of file1.');
    halt;
  end;
  in_name:=paramstr(1);
  out_name:=paramstr(2);
  if in_name = out_name then begin
    writeln;
    writeln('ERROR: You are attempting to replace a file onto itself.',
            '  Program terminating.');
    halt;
    end;
  if not exists(in_name) then begin
    writeln;
    writeln('ERROR: ',in_name,' does not exist.  Program terminating.');
    halt;
    end;
  if not exists(out_name) then begin
    writeln;
    write('WARNING: ',out_name,' does not exist.  Program terminating.');
    halt;
  end;
  assign (in_file,in_name);
  reset (in_file,1);
  assign (out_file,out_name);
  reset (out_file,1);
  repeat
    blockread (in_file,buffer,16384,recs);
    blockwrite (out_file,buffer,recs);
  until recs=0;
  truncate(out_file);
  close (in_file);
  close (out_file);
end.
