program rep_all;

uses Dos;

var
  line : string;
  s1, s2 : string;
  f1, f2 : text;
  DirInfo: SearchRec;
  p : byte;
  n : word;

begin
  if paramstr(1) = '' then begin
    writeln;
    writeln('  REP_ALL wild_file_spec [search_token replace_token]');
    writeln;
    writeln('    Replaces all occurences in all specificed files.');
    writeln('    Only works on text files (lines terminated with CR/LF).');
    writeln('    If blanks or DOS special characters are needed in tokens,');
    writeln('    just specify a wild_file_spec and you will be prompted');
    writeln('    for search and replacement strings.');
    writeln('    The replace_token cannot contain the search_token.');
    writeln('    REL_ALL is case sensitive.');
    halt;
  end;
  if paramstr(3) = '' then begin
    write('     Search string : ');
    readln(s1);
    write('Replacement string : ');
    readln(s2);
  end
  else begin
    s1 := paramstr(2);
    s2 := paramstr(3);
  end;

  if pos(s1, s2) > 0 then begin
    writeln('  ERROR: The replace_token cannot contain the search_token.');
    halt;
  end;

  FindFirst(paramstr(1), AnyFile, DirInfo);
  while DosError = 0 do begin
    writeln('Processing ', DirInfo.Name);
    n := 0;
    assign(f1, DirInfo.Name);
    reset(f1);
    assign(f2, '$scratch.$$$');
    rewrite(f2);
    repeat
      readln(f1, line);
      while pos(s1, line) > 0 do begin
        inc(n);
        p := pos(s1, line);
        delete(line, p, length(s1));
        insert(s2, line, p);
      end;
      writeln(f2, line);
    until eof(f1);

    writeln(n:8, ' replacements made.');
    close(f2);
    close(f1);
    erase(f1);
    rename(f2, DirInfo.Name);
    FindNext(DirInfo);
  end;
end.

