program tab2spc;  {replaces tabs with spaces}
var
   in_name,out_name : string[80];
   in_file,out_file : file;
   in_buff          : array [1..10000] of byte;
   out_buff         : array [1..50000] of byte;
   recs             : integer;
   ch               : char;
   i                : integer;
   j                : integer;
   k                : integer;
   n                : integer;
   n_spaces         : integer;
   code             : integer;

function exists(var filename_of_any_string_length):boolean;
var
  filename : string[255] absolute filename_of_any_string_length;
  filein : text;
begin
  assign(filein,filename);
  {$I-}
  reset(filein);
  {$I+}
  if ioresult = 0 then begin
    exists:=true;
    close(filein);
    end
  else exists:=false;
  end; {exists}

begin
  n := 0;
  if paramstr(3) = '' then begin
    writeln;
    writeln(' This program converts tabs to a user defined number of spaces.');
    writeln(' Syntax:   TABS2SPC  in_file_name  out_file_name  n_spaces');
    writeln(' n_spaces must be 1 to 9.');
    writeln;
    halt;
  end;

  in_name:=paramstr(1);
  out_name:=paramstr(2);
  val(paramstr(3), n_spaces, code);
  if (code <> 0) or not (n_spaces in [1..9]) then begin
    writeln('Syntax error!  Type TABS2SPC for help.');
    halt;
  end;

  if in_name = out_name then begin
    writeln;
    writeln('ERROR: You are attempting to copy a file onto itself.',
            '  Program terminating.');
    halt;
    end;
  if not exists(in_name) then begin
    writeln;
    writeln('ERROR: ',in_name,' does not exist.  Program terminating.');
    halt;
    end;
  if exists(out_name) then begin
    writeln;
    write('WARNING: ',out_name,' exists.  Do you want to copy over it? ');
    readln(ch);
    if upcase(ch) <> 'Y' then halt;
    end;
  assign (in_file,in_name);
  reset (in_file,1);
  assign (out_file,out_name);
  rewrite (out_file,1);
  repeat
    blockread (in_file,in_buff,10000,recs);
    j := 0;
    for i := 1 to recs do begin
      if in_buff[i] = 9 {tab} then begin
        inc(n);
        for k := 1 to n_spaces do begin
          inc(j);
          out_buff[j] := 32 {space};
        end;
      end
      else begin
        inc(j);
        out_buff[j] := in_buff[i];
      end;
    end;
    blockwrite (out_file,out_buff,j);
    until recs=0;
  close (in_file);
  close (out_file);
  writeln(n, ' tabs converted.');
  end.
