program unmerge;

{unmerges a merge file into a set of files; see merge.pas}

uses dos, crt;

const
  max_lines = 10000;
  n_allocated : word = 0;
var
  i, n, p : integer;
  merge_file_name : string;
  out_file_name : string;
  str, old_str : string;
  out_file,in_file, old_file : text;
  different : boolean;
  line : array[1..max_lines] of ^string;
  first_time : boolean; {for max lines exceeded}
  n_changed, n_not_changed : integer;

procedure invalid;
begin
  writeln;
  writeln('Error: Invalid merge file. Program aborted.');
  halt;
end;

begin {main}
  if paramcount <> 1 then begin
    writeln;
    writeln('This program unmerges a merge file into a set of text files.');
    writeln('MERGE and UNMERGE may be used to allow a global edit a set of files.');
    writeln('Refer to merge.exe for more information.');
    writeln;
    writeln('Syntax: UNMERGE merge_file');
    writeln;
    halt;
  end;

  n_changed := 0;
  n_not_changed := 0;
  merge_file_name := paramstr(1);
  assign(in_file, merge_file_name);
  reset(in_file);

  readln(in_file);
  readln(in_file);
  readln(in_file);
  readln(in_file, str);
  if str[1] <> '>' then invalid;

  repeat
    readln(in_file);
    p := pos(' ', str);
    out_file_name := copy(str, p+1, 13);
    p := pos(' ', out_file_name);
    out_file_name[0] := chr(p-1);
    write('Processing ', out_file_name);
    n := 0;
    first_time := true;
    repeat
      inc(n);
      if n > n_allocated then begin
        new(line[n]);
        inc(n_allocated);
        if n_allocated = max_lines then begin
          if first_time then begin
            writeln('  Max lines exceeded; ', out_file_name, ' truncated.');
            first_time := false;
          end;
          dec(n);
        end;
      end;
      readln(in_file, line[n]^);
    until eof(in_file) or (copy(line[n]^,1,5) = '>>>>>');
    if not eof(in_file) then begin
      str := line[n]^;
      dec(n,4);
    end;

    {see if file has changed}
    different := false;
    assign(old_file, out_file_name);
    {$I-}
    reset(old_file);
    {$I+}
    if ioresult = 0 then begin
      i := 0;
      while not different and (i <> n) do begin
        readln(old_file, old_str);
        inc(i);
        if (old_str <> line[i]^) then different := true;
      end;
      close(old_file);
    end
    else different := true;

    if different then begin
      assign(out_file, out_file_name);
      rewrite(out_file);
      for i := 1 to n do begin
        writeln(out_file, line[i]^);
      end;
      close(out_file);
      writeln(' - ', n, ' records written.                               ');
      inc(n_changed);
    end
    else begin
      gotoxy(1, wherey);
      clreol;
      inc(n_not_changed);
    end;
  until eof(in_file);
  close(in_file);
  writeln(n_changed + n_not_changed, ' files processed.');
  writeln(n_changed, ' files updated');;
end.
