program uplocase;

var
  filein     : text;
  fileout    : text;
  line       : string;
  p          : byte;
  ch         : char;
  in_comment : boolean;
  in_FORTRAN_comment : boolean;
  in_quote   : boolean;
  upcasing   : boolean;

begin {main}

  writeln('This program converts Pascal or FORTRAN programs to all upper case');
  writeln('or all lower case (exluding comments and string constants).');
  writeln;

  repeat
    write('Enter desired conversion: (U)pper case or (L)ower case ? ');
    readln(ch);
    ch := upcase(ch);
  until ch in ['U', 'L'];
  upcasing := ch = 'U';

  write('Enter input file name: ');
  readln(line);
  assign(filein,line);
  reset(filein);

  write('Enter output file name: ');
  readln(line);
  assign(fileout,line);
  rewrite(fileout);

  in_comment := false;
  in_FORTRAN_comment := false;
  in_quote := false;

  repeat

    readln(filein,line);

    in_FORTRAN_comment := line[1] in ['*', 'C', 'c', '!'];
    for p := 1 to length(line) do begin
      ch := line[p];
      if (ch = '''') and not in_comment
         and not in_FORTRAN_comment then in_quote := not in_quote;
      if (ch = '{')  and not in_quote   then in_comment := true;
      if (ch = '}')  and not in_quote   then in_comment := false;
      if (ch = '!')  and not in_quote   then in_FORTRAN_comment := true;

      if upcasing then begin
        if ch in ['a' .. 'z'] then begin
          if not in_quote and not in_comment and not in_FORTRAN_comment then begin
            line[p] := upcase(ch)
          end;
        end;
      end

      else {convert to lower case}
        if ch in ['A' .. 'Z'] then begin
          if not in_quote and not in_comment and not in_FORTRAN_comment then begin
            line[p] := char(ord(ch)+32);
          end;
        end;
    end;

    writeln(fileout,line);
    writeln(line);

  until eof(filein);

  close(filein);
  close(fileout);

end.
